/****************************************************************************************************************************************
/* Implementa InterfaceAplicacio
 *****************************************************************************************************************************************/


using System;
using System.Collections.Generic;
using System.Text;

using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using PFC.gestorAplicacio;

namespace PFC.Aplicacio_
{
    
   
    class Aplicacio:InterfaceAplicacio
    {
       /*****************VARIABLES QUE UTILITZAR L'APLICACI***************************/ 
        //public String rutaImatges = "C:\\Restaural\\PFC\\Imatges\\";
        //public String rutaResources = "C:\\Restaural\\PFC\\Resources\\";
        public String rutaImatges = Environment.CurrentDirectory + "\\Imatges\\";
        public String rutaResources = Environment.CurrentDirectory + "\\Resources\\";
        public String estat1 = "Inicial";
        public String estat2 = "Elaborant";
        public String estat3 = "Finalitzat";
        public String comandaEstat3 = "Pendent cobrar";
        public String estatEliminada = "Eliminada";
        public Image imatgeNotaAfegida;
        public Image imatgeNoDisponible;
        public Image imatgeCreaPostres;
        public Image lineaInicial;
        public Image lineaElaborant;
        public Image lineaFinalitzada;

        public Color colorPrimerPlat = System.Drawing.Color.Aquamarine;
        public Color colorSegonPlat = System.Drawing.Color.DarkOrange;
        public Color colorPostres = System.Drawing.Color.Yellow;

        
        
        gestor Gestor = new gestor();

        public void IniciarAplicacio()
        {
            try
            {
                Gestor.IniciarAplicacio();//Configura tot el mapeix de nhibernate i crea inici de sessi
            }
            catch (Exception e) { throw e; }

            imatgeNotaAfegida = new Bitmap(rutaResources + "afegirNota.png");
            imatgeNoDisponible = new Bitmap(rutaResources + "imatgeNodisponible.gif");
            imatgeCreaPostres = new Bitmap(rutaResources + "postres.jpg");

            lineaInicial = new Bitmap(rutaResources + "lineaInicial.jpg");
            lineaElaborant = new Bitmap(rutaResources + "lineaElaborant.jpg");
            lineaFinalitzada = new Bitmap(rutaResources + "lineaFinalitzada.jpg");
        }


/****************************************************************************************************************************************
/* Implementaci de tots els mtodes comuns per l'aplicaci principal i la de administraci
*****************************************************************************************************************************************/
             
        
        
        public IList obtenirProductes()
        {
            return Gestor.getProductes();

        }

        public IList obtenirProductes(GrupProducte g)
        {
            return Gestor.getProductes(g);

        }

        public Producte obtenirProducte(int id)
        {
            return Gestor.getProducte(id);
        }

        public Producte obtenirProducte(string s)
        {
            return Gestor.getProducte(s);
        }


        public IList obtenirProductesGrup(GrupProducte gp)
        {
            return Gestor.getProductesGrup(gp);
        }


        public IList obtenirGrupsProductes()
        {
            return Gestor.getGrupsProductes();
        }


        public GrupProducte obtenirGrupProducte(int id)
        {
            return Gestor.getGrupProducte(id);
        }

        public GrupProducte obtenirGrupProducte(string s)
        {
            return Gestor.getGrupProducte(s);
        }



        public IList obtenirCambrers()
        {
            return Gestor.getCambrers();
        }


        public Cambrer obtenirCambrer(int id)
        {
            return Gestor.getCambrer(id);
        }

        public IList obtenirTaules()
        {
            return Gestor.getTaules();
        }


        public Taula obtenirTaula(int id)
        {
            return Gestor.getTaula(id);
        }

        public Taula obtenirTaula(string nom)
        {
            return Gestor.getTaula(nom);
        }

        public IList obtenirNotes()
        {
            return Gestor.getNotes();
        }
        
        public NotesAdicionals obtenirNota(int id)
        {
            return Gestor.getNota(id);
        }

        public NotesAdicionals obtenirNota(string nom)
        {
            return Gestor.getNota(nom);
        }


        public IList obtenirPagaments()
        {
            return Gestor.getPagaments();
        }

        public IList obtenirPagaments(int idtipusPagament, String DataInici, String DataFinal)
        {
            return Gestor.getPagaments(idtipusPagament, DataInici, DataFinal);
        }

        public IList obtenirComandesNoPagades()
        {
            return Gestor.getComandesNoPagades();
        }

      
        public bool guardarPagament(Pagament p)
        {
            return Gestor.setPagament(p);
        }


        public bool eliminarPagament(Pagament p)
        {
            return Gestor.eliminaPagament(p);
        }

        public IList obtenirTipusPagaments()
        {
            return Gestor.getTipusPagaments();
        }

        public TipusPagament obtenirTipusPagament(int id)
        {
            return Gestor.getTipusPagament(id);
        }

        public bool guardarTipusPagament(TipusPagament p)
        {
            return Gestor.setTipusPagament(p);
        }


        public bool eliminarTipusPagament(TipusPagament p)
        {
            return Gestor.eliminaTipusPagament(p);
        }


        //Determina la imatge de estat segons quin sigui el seu estat
        public Image determinaImatgeEstat(String estat)
        {
            Image imatgeEstat = null;
            switch (estat)
            {
                case "Inicial": imatgeEstat = lineaInicial; break;
                case "Elaborant": imatgeEstat = lineaElaborant; break;
                case "Finalitzat": imatgeEstat = lineaFinalitzada; break;
            }
            return imatgeEstat;
        }
    }
}