/****************************************************************************************************************************************
/* Implementa InterfaceAplicacioAdministracio
 *****************************************************************************************************************************************/


using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using PFC.gestorAplicacio;

namespace PFC.Aplicacio_
{
    class AplicacioPrincipal:Aplicacio,InterfaceAplicacioPrincipal
     {
        gestorAplicacioPrincipal gp = new gestorAplicacioPrincipal();
       

/****************************************************************************************************************************************
/* Implementaci de tots els mtodes de la aplicaci principal
*****************************************************************************************************************************************/

        //******************************Retorna la comanda actual de la taula passada per parmetre************************
        public Comanda obtenirComandaActual(Taula t)
        {
            return gp.getComandaActual(t);
        }

        public Comanda obtenirComanda(int id)
        {
            return gp.getComanda(id);
        }

        //******************************Retorna totes les comandes de la BD************************
        public IList obtenirComandes()
        {
            return gp.getComandes();
        }

        //******************************Retorna la comanda actual de la taula passada per parmetre************************
        public IList obtenirLineasComanda(Comanda c)
        {
            return gp.getLineasComanda(c);
        }

        //******************************Retorna totes les linees comanda de la BD************************
        public IList obtenirLineasComanda()
        {
            return gp.getLineasComanda();
        }

        //******************************Retorna totes les linees comanda de cuina de la BD************************
        public IList obtenirLineasCuina(Comanda c)
        {
            return gp.getLineasCuina(c);
        }

        //******************************Retorna totes les linees comanda de barra la BD************************
        public IList obtenirLineasBarra(Comanda c)
        {
            return gp.getLineasBarra(c);
        }

        //******************************Retorna totes les linees comanda de Bodega la BD************************
        public IList obtenirLineasBodega(Comanda c)
        {
            return gp.getLineasBodega(c);
        }

        //******************************Retorna totes les linees comanda de postres la BD************************
        public IList obtenirLineasPostres(Comanda c)
        {
            return gp.getLineasPostres(c);
        }
        //******************************Retorna una linea comanda de la BD************************
        public LineaComanda obtenirLineaComanda(int comanda,int producte,string nota,string preferencia)
        {
            return gp.getLineaComanda(comanda,producte,nota,preferencia);
        }



        //******************************Guardem i/o modifiquem la comanda passada per parmetre************************
        public bool guardarComanda(Comanda c)
        {
            return gp.setComanda(c);
        }

        //******************************Eliminem la comanda passat per parmetre************************
        public bool eliminarComanda(Comanda c)
        {
            return gp.eliminaComanda(c);
        }
        //******************************Guardem la lineacomanda a la bd************************
        public bool guardarLineaComanda(LineaComanda l)
        {
            return gp.setLineaComanda(l);
        }

        //******************************Eliminem la lineacomanda passada per parmetre************************
        public bool eliminarLineaComanda(LineaComanda l)
        {
            return gp.eliminaLineaComanda(l);
        }

/*****************************AUXILIARS**********************************************************************************/



        //******************************Mira si existeix una linea comanda amb els parmetres idComanda , idProducte************************
        public bool existeixLinea(int idComanda, int idProducte,string nota,string preferencia)
        {
            bool res=true;
            try
            {
                gp.getLineaComanda(idComanda, idProducte,nota,preferencia);
            }
            catch (Exception) { res = false; } //Si s'ha llenat excepci es perque no l'hja trobat, per tant no existeix.
            return res;
        }

        //******************************Mira si existeix una linea comanda amb els parmetres idComanda , idProducte************************
        public bool existeixComanda(Taula t)
        {
            bool res = true;
            try
            {
                gp.getComandaActual(t);
            }
            catch (Exception) { res = false; } //Si s'ha llenat excepci es perque no l'hja trobat, per tant no existeix.
            return res;
        }

        //Comproba l'estat de cada linea de comanda i a partir d'aquestes determina l'estat de la comanda
        public String determinaEstatComanda(Comanda c,int opcio)
        {
            String estatComanda = c.Estat;
            IList i = c.Lineas;
                int productesFinalitzats = 0;
            
                
                foreach (LineaComanda l in i)
                {
                    if (!l.Estat.Equals(estat1)) //Noms que hi hagi una linea diferent de Inicial es que s'est elaborant la comanda
                        estatComanda = estat2;

                    if (l.Estat.Equals(estat3)) //Anem acumulant quantes lines estan finalitzades.. si totes ho estan,la comanda tamb ho estara
                        productesFinalitzats++;

                }

                if ((estatComanda == comandaEstat3) && (productesFinalitzats != c.Lineas.Count))//Si teniem comanda finalitzada i restem algun producte,tornarem a lestat elaborant
                    estatComanda = estat2;

                if ((productesFinalitzats == c.Lineas.Count) && (c.Lineas.Count != 0)) //Si totes les linees estan finalitzades
                    estatComanda = comandaEstat3;
              
            

            return estatComanda;

        }

        //Determina l'estat de la linea de comanda i de l'atribut quantsFinalitzats
        public void determinaEstatLinea(LineaComanda l,string opcio)
        {
          switch(opcio)
          {
              case "afegir":

            if (l.QuantsFinalitzats != l.Quantitat) //Sempre i quant no els haguem elaborat tots els de la linea..
            {
                if (l.QuantsFinalitzats + 1 == l.Quantitat) //Si es el penultim per fer,s far i es posar la linea com a finalitzada
                    l.Estat = estat3;
                else l.Estat = estat2;
                l.QuantsFinalitzats = l.QuantsFinalitzats + 1;
            }

            break; 

              case "treure":
            if (l.QuantsFinalitzats != 0) //Sempre i quant ja hi hagi algun finalitzat que volguem treure
            {
                if (l.QuantsFinalitzats - 1 == 0) //Si es el penultim per fer,s far i es posar la linea com a finalitzada
                    l.Estat = estat1;
                else l.Estat = estat2;
                l.QuantsFinalitzats = l.QuantsFinalitzats - 1;
            }
            break;

        }
        }

       


    }
}