/****************************************************************************************************************************************
/* Interficie que cont tots els mtodes comuns que utilitzara la interficie grfica final.
 * Aquesta classe utilitza la seva inferior(gestorAplicacio) per accedir a les dades i les comunica amb l'aplicaci final(Intf grfica)
 *****************************************************************************************************************************************/


using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Collections;


namespace PFC.Aplicacio_
{
    interface InterfaceAplicacio
    {

//******************************Operacions de lectura de producte**********************************************

        //******************************Obtenim tots els productes disponibles************************
        IList obtenirProductes();

        //******************************Obtenim tots els productes de un grup ordenat  per nom************************
        IList obtenirProductes(GrupProducte g);

        //******************************Obtenim el producte amb el id passat per parmetre************************
        Producte obtenirProducte(int id);

        //******************************Obtenim el  producte amb el string passat per parmetre************************
        Producte obtenirProducte(string s);
      
       

//******************************Operacions de lectura de grups producte**********************************************

        //******************************Obtenim tots els grups productes disponibles************************
        IList obtenirGrupsProductes();

        //******************************Obtenim el grup producte amb el id passat per parmetre************************
        GrupProducte obtenirGrupProducte(int id);

        //******************************Obtenim el grup producte amb el string passat per parmetre************************
        GrupProducte obtenirGrupProducte(string s);

//******************************Operacions de lectura de cambrer**********************************************

        //******************************Obtenim tots els cambrers disponibles************************
        IList obtenirCambrers();

        //******************************Obtenim el cambrer amb el id passat per parmetre************************
        Cambrer obtenirCambrer(int id);


//******************************Operacions de lectura de taula**********************************************

        //******************************Obtenim tots les taules disponibles************************
        IList obtenirTaules();

        //******************************Obtenim la taula amb el id passat per parmetre************************
        Taula obtenirTaula(int id);

        //******************************Obtenim la taula amb el nom passat per parmetre************************
        Taula obtenirTaula(string nom);

//******************************Operacions de lectura de notes adicionals**********************************************

        //******************************Obtenim tots les notes disponibles************************
        IList obtenirNotes();

        //******************************Obtenim la nota amb el id passat per parmetre************************
        NotesAdicionals obtenirNota(int id);

        //******************************Obtenim la nota amb el nom passat per parmetre************************
        NotesAdicionals obtenirNota(string nom);


//******************************Operacions de pagaments**********************************************

        //******************************Obtenim tots els pag.************************
        IList obtenirPagaments();
        //******************************Guardem i/o modifiquem el pagament passat per parmetre************************
        bool guardarPagament(Pagament p);

        //******************************Eliminem el pagament passat per parmetre************************
        bool eliminarPagament(Pagament p);

 //******************************Operacions de tipus pagaments**********************************************

        //******************************Obtenim tots els pag.************************
        IList obtenirTipusPagaments();
        //******************************Obtenim el pag. passat x id************************
        TipusPagament obtenirTipusPagament(int id);
        //******************************Guardem i/o modifiquem el pagament passat per parmetre************************
        bool guardarTipusPagament(TipusPagament p);

        //******************************Eliminem el pagament passat per parmetre************************
        bool eliminarTipusPagament(TipusPagament p);

    }
}
