/******************************
 * Hereta de Controlador
 * ****************************/
using System;
using System.Collections;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller
{
   public  class ControlCambrer : Controlador
    {
       static private ControlCambrer _instance;

        //*********************************Obtencio de tots els cambrers de la BD*********************************      
       public IList loadCambrers()
       {
           IList cambrers = null;

           try
           {
               ReconnectSession();
               //cambrers = session.CreateCriteria(typeof(Cambrer)).List();
               cambrers = session.Find("from PFC.Cambrer as g where g.Actiu=1");

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlCambrer.cs:Error Carregant cambrers: " + ex.Message);

           }

           return cambrers;
       }


       //*********************************Obtencio del cambrer amb el id passat*********************************      
       public Cambrer loadCambrer(int id)
       {
           Cambrer cambrer = null;

           try
           {
               cambrer = (Cambrer)session.Load(typeof(Cambrer), id);
               session.Refresh(cambrer);
           }
           catch (HibernateException ex)
           {
               throw new Exception("ControlCambrer.cs:No s'ha pogut carregar el cambrer"+id+ ": " + ex.Message);
           }

           return cambrer;
       }

       //*********************************Guarda a la BD la comanda passada per parmetre*********************************      
       public bool saveCambrer(Cambrer c)
       {
           ITransaction tx = null;
               bool res = true;
               
               try
               {
                  
                   tx = session.BeginTransaction();
                   if (c.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                   {
                       c.Actiu = true;
                       session.Save(c);

                   }
                   else
                   {
                       session.Update(c);
                   }
                   tx.Commit();


                   
               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   throw new Exception("ControlCambrer.cs:No s'ha pogut guardar el cambrer: " + ex.Message);
                  
               }
               
               return res;
           }

           //*********************************Esborra de la BD el cambrer*********************************    
           public bool deleteCambrer(Cambrer c)
           {
               bool res = true;
               ITransaction tx = null;
               try
               {

                   tx = session.BeginTransaction();
                   session.Delete(c);
                   tx.Commit();

               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
                   res = false;
                   throw new Exception("ControlCambrer.cs:No s'ha pogut esborrar el Cambrer " + ex.ToString());

               }

               return res;
           }

       //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
       public static ControlCambrer getInstance()
       {
           if (_instance == null) { _instance = new ControlCambrer(); }
           return _instance;
       }

       }
     
       
    }


