/******************************
 * Hereta de Controlador
 * ****************************/

using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller 
{
    public class ControlGrupProducte : Controlador 
    {
        static private ControlGrupProducte _instance;
        
       

        //*********************************Carrega tots els grups de productes*********************************
        public IList loadGrupsProductes() 
        {
            IList grups = null;

            try
	        {
             ReconnectSession(); 
                //Al haver-hi la mateixa aplicaci treballant concurrentment en les pda's i tactils,he de crear una altra conexi
                //per tenir-ho tot absolutament actualitzat en tems real.
             // grups = session.CreateCriteria(typeof(GrupProducte)).List();
              
              grups=session.Find("from PFC.GrupProducte as g where g.Disponible=1 order by g.Nom");
	        }
	        catch (HibernateException ex)
	        {
                throw new Exception("ControlGrupProducte.cs:No s'ha pogut carregar els Grupsproductes: " + ex.Message);
            }
           
            return grups;
}

        //*********************************Obtenci de grup producte segons el seu Id*********************************
         public GrupProducte loadGrupProducte(int id)
        {
            GrupProducte grup = null;
           
               
                try
                {
                    grup = (GrupProducte)session.Load(typeof(GrupProducte), id);
                
                    session.Refresh(grup);
                }
                catch (HibernateException ex)
                {
                    throw new Exception("ControlGrupProducte.cs:No s'ha pogut carregar els GrupProducte "+id+": " + ex.Message);
                }
                
                return grup;
        }

        //*********************************Obtenci de grup producte segons el seu nom*********************************
        public GrupProducte loadGrupProducte(string s)
        {
            GrupProducte grup = null;
            IList i = null;

            try
            {
             //   grup = (GrupProducte)session.Load(typeof(GrupProducte), id);
                i = session.Find("from PFC.GrupProducte as g where g.Nom='" + s+"'");
                foreach (GrupProducte g in i)
                    grup = g;

                session.Refresh(grup);
            }
            catch (HibernateException ex)
            {
                throw new Exception("ControlGrupProducte.cs:No s'ha pogut carregar els GrupProducte " + s + ": " + ex.Message);
            }

            return grup;
        }

        //*********************************Guarda a la BD el grupproducte*********************************    
        public bool saveGrupProducte(GrupProducte g)
        {
            bool res = true;
            ITransaction tx = null;
           
            try
            {

                tx = session.BeginTransaction();

                if (g.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                {
                    g.Disponible = true;
                    session.Save(g);
                }
                else
                {
                    session.Update(g);
                   
                                       
                }

                tx.Commit();
               

            }
            catch (HibernateException ex)
            {
                tx.Rollback();
                res = false;
                throw new Exception("ControlGrupProducte.cs:No s'ha pogut guardar el GrupProducte:" + ex.Message);
               
            }
           

            return res;
        }

      //*********************************Esborra de la BD el Grupproducte*********************************    
      public bool deleteGrupProducte(GrupProducte g)
      {
          bool res = true;
          ITransaction tx = null;
          try
          {
              
              tx = session.BeginTransaction();
              session.Delete(g);
              tx.Commit();

          }
          catch (HibernateException ex)
          {
              tx.Rollback();
              session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
              res = false;
              throw new Exception("ControlGrupProducte.cs:No s'ha pogut esborrar el GrupProducte " + ex.ToString());
              
          }
          
          return res;
      }

      //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
        public static  ControlGrupProducte getInstance() {
            if (_instance == null) { _instance = new ControlGrupProducte(); }
        return _instance;
    }


}
}
