/******************************
 * Hereta de Controlador
 * ****************************/

using System;
using System.Collections;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller
{
   public  class ControlLineaComanda : Controlador
    {
       static private ControlLineaComanda _instance;
       

        //*********************************Obtencio de totes les lineas de comandes de la BD*********************************      
       public IList loadLineasComanda()
       {
           IList comandes = null;

           try
           {
               ReconnectSession(); 
               comandes = session.CreateCriteria(typeof(LineaComanda)).List();

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlLineaComanda.cs:Error Carregant lineas de comanda: " + ex.Message);

           }

           return comandes;
       }


       //*********************************Obtencio de les TOTES lineas de comanda de la comanda passada per parmetre*********************************      
       public IList loadLineasComanda(Comanda c)
       {
           IList lineas = null;
          
           try
           {

               lineas = session.Find("from PFC.LineaComanda as l where l.Comanda.Id=" + c.Id +" order by l.Preferencia");
              
              
           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlLineaComanda.cs:Error Carregant lineas de la comanda " + c.Id + ":" + ex.Message);

           }

           return lineas;
       }


       //*********************************Obtencio de les lineas de comanda de la comanda que s'envien A CUINA passada per parmetre*********************************      
       public IList loadLineasCuina(Comanda c)
       {
           IList lineas = null;

           try
           {

               lineas = session.Find("from PFC.LineaComanda as l where l.Comanda.Id=" + c.Id+" and l.Producte.Grup.Enviar_a='Cuina'");
              

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlLineaComanda.cs:Error Carregant lineas de cuina de la comanda " + c.Id + ":" + ex.ToString());

           }

           return lineas;
       }

       //*********************************Obtencio de les lineas de comanda de la comanda que s'envien A BARRA passada per parmetre*********************************      
       public IList loadLineasBarra(Comanda c)
       {
           IList lineas = null;

           try
           {

               lineas = session.Find("from PFC.LineaComanda as l where l.Comanda.Id=" + c.Id + " and l.Producte.Grup.Enviar_a='Barra'");
              

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlLineaComanda.cs:Error Carregant lineas de barra de la comanda " + c.Id + ":" + ex.Message);

           }

           return lineas;
       }

       //*********************************Obtencio de les lineas de comanda de la comanda que s'envien A BODEGA  passada per parmetre*********************************      
       public IList loadLineasBodega(Comanda c)
       {
           IList lineas = null;

           try
           {

               lineas = session.Find("from PFC.LineaComanda as l where l.Comanda.Id=" + c.Id + " and l.Producte.Grup.Enviar_a='Bodega'");
               

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlLineaComanda.cs:Error Carregant lineas de bodega de la comanda " + c.Id + ":" + ex.ToString());

           }

           return lineas;
       }

       //*********************************Obtencio de les lineas de comanda de la comanda que s'envien A POSTRES passada per parmetre*********************************      
       public IList loadLineasPostres(Comanda c)
       {
           IList lineas = null;

           try
           {

               lineas = session.Find("from PFC.LineaComanda as l where l.Comanda.Id=" + c.Id + " and l.Producte.Grup.Enviar_a='Postres'");


           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlLineaComanda.cs:Error Carregant lineas de postres de la comanda " + c.Id + ":" + ex.ToString());

           }

           return lineas;
       }

       //*********************************Obtencio de la linea de comanda amb idComanda,idProducte passat per parmetre*********************************      
       public LineaComanda loadLineaComanda(int idComanda,int idProducte,string nota,string preferencia)
       {
           IList i = null;
           LineaComanda l = null;
           //if (nota == null) nota = "";
           try
           {

               i = session.Find("from PFC.LineaComanda as l where l.Comanda.Id="+idComanda+" and l.Producte.Id="+idProducte+" and l.NotaAdicional='"+nota+"' and l.Preferencia='"+preferencia+"'");
               foreach (LineaComanda li in i)
                   l = li;
               session.Refresh(l);

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlLineaComanda.cs:Error Carregant linea de comanda:" + ex.ToString());

           }

           return l;
       }


       //*********************************Guarda a la BD la linea de comanda passada per parmetre*********************************      
       public bool saveLineaComanda(LineaComanda c)
       {
           ITransaction tx = null;
               bool res = true;
               
               try
               {
                  
                   tx = session.BeginTransaction();
                   if (c.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                   {
                       
                       session.Save(c);

                   }
                   else
                   {
                       session.Update(c);
                   }
                   tx.Commit();


                   
               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   throw new Exception("ControlLineaComanda.cs:No s'ha pogut guardar la linea comanda: " + ex.ToString());
                  
               }
               
               return res;
           }


           //*********************************Esborra de la BD la lineaComanda*********************************    
           public bool deleteLineaComanda(LineaComanda l)
           {
               bool res = true;
               ITransaction tx = null;
               try
               {

                   tx = session.BeginTransaction();
                   session.Delete(l);
                   tx.Commit();

               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
                   throw new Exception("ControlLineaComanda.cs:No s'ha pogut esborrar la Linea " + ex.ToString());

               }

               return res;
           }


       //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
       public static ControlLineaComanda getInstance()
       {
           if (_instance == null) { _instance = new ControlLineaComanda(); }
           return _instance;
       }

       }
     
       
    }


