/******************************
 * Hereta de Controlador
 * ****************************/

using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller 
{
    public class ControlNotesAdicionals : Controlador 
    {
        static private ControlNotesAdicionals _instance;
        
       

        //*********************************Carrega totes les notes*********************************
        public IList loadNotes() 
        {
            IList notes = null;

            try
	        {
             ReconnectSession(); 
                //Al haver-hi la mateixa aplicaci treballant concurrentment en les pda's i tactils,he de crear una altra conexi
                //per tenir-ho tot absolutament actualitzat en tems real.
             notes = session.CreateCriteria(typeof(NotesAdicionals)).List();

             
	        }
	        catch (HibernateException ex)
	        {
                throw new Exception("ControlNotesAdicionals.cs:No s'ha pogut carregar les notes: " + ex.Message);
            }

            return notes;
}




        //*********************************Obtenci de una nota segons el seu Id*********************************
        public NotesAdicionals loadNota(int id)
        {
            NotesAdicionals nota = null;
           
               
                try
                {
                    nota = (NotesAdicionals)session.Load(typeof(NotesAdicionals), id);

                    session.Refresh(nota);
                }
                catch (HibernateException ex)
                {
                    throw new Exception("ControlNotesAdicionals.cs:No s'ha pogut carregar la nota "+id+": " + ex.Message);
                }

                return nota;
        }

        //*********************************Obtenci de nota segons la descripcio*********************************
        public NotesAdicionals loadNota(string s)
        {
            NotesAdicionals nota = null;
            IList i = null;

            try
            {
           
                i = session.Find("from PFC.NotesAdicionals as n where n.Descripcio='" + s+"'");
                foreach (NotesAdicionals n in i)
                    nota = n;

                session.Refresh(nota);
            }
            catch (HibernateException ex)
            {
                throw new Exception("ControlNotesAdicionals.cs:No s'ha pogut carregar la nota " + s + ": " + ex.Message);
            }

            return nota;
        }

        //*********************************Guarda a la BD el grupproducte*********************************    
        public bool saveNota(NotesAdicionals g)
        {
            bool res = true;
            ITransaction tx = null;
           
            try
            {

                tx = session.BeginTransaction();

                if (g.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                {
                    
                    session.Save(g);
                }
                else
                {
                    session.Update(g);
                   
                                       
                }

                tx.Commit();
               

            }
            catch (HibernateException ex)
            {
                tx.Rollback();
                res = false;
                throw new Exception("ControlNotesAdicionals.cs:No s'ha pogut guardar la nota:" + ex.Message);
               
            }
           

            return res;
        }

      //*********************************Esborra de la BD el Grupproducte*********************************    
      public bool deleteNota(NotesAdicionals g)
      {
          bool res = true;
          ITransaction tx = null;
          try
          {
              
              tx = session.BeginTransaction();
              session.Delete(g);
              tx.Commit();

          }
          catch (HibernateException ex)
          {
              tx.Rollback();
              session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
              res = false;
              throw new Exception("ControlNotesAdicionals.cs:No s'ha pogut esborrar la nota " + ex.ToString());
              
          }
          
          return res;
      }

      //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
        public static ControlNotesAdicionals getInstance()
        {
            if (_instance == null) { _instance = new ControlNotesAdicionals(); }
        return _instance;
    }


}
}
