/******************************
 * Hereta de Controlador
 * ****************************/

using System;
using System.Collections;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller
{
   public  class ControlPagament : Controlador
    {
       static private ControlPagament _instance;

      
       
       //*********************************Obtencio de tots els pagaments de la BD*********************************      
       public IList loadPagaments()
       {
           IList pagaments = null;

           try
           {
               ReconnectSession();
              pagaments = session.CreateCriteria(typeof(Pagament)).List();

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlPagament.cs:Error Carregant pagaments: " + ex.ToString());

           }

           return pagaments;
       }


       //*********************************Filtratge de pagaments amb els camps tipus i data*********************************      
       public IList loadPagaments(int idtipusPagament,String DataInici,String DataFinal)
       {
           IList pagaments = null;
           if (DataInici == "") DataInici = "1700/01/01";
           if (DataFinal == "") DataFinal = "2200/01/01";

           try
           {
               ReconnectSession();
                if(idtipusPagament==-1)
                    pagaments = session.Find("from PFC.Pagament as p where p.Data between '" + DataInici + "' and '" + DataFinal + "'");
                else
                pagaments = session.Find("from PFC.Pagament as p where p.TipusPagament.Id="+idtipusPagament+" and p.Data between '"+DataInici+"' and '"+DataFinal+"'");
           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlPagament.cs:Error Carregant pagaments: " + ex.ToString());

           }

           return pagaments;
       }


       //*********************************Guarda a la BD el pagament passat per parmetre*********************************      
       public bool savePagament(Pagament c)
       {
           ITransaction tx = null;
               bool res = true;
               
               try
               {
                  
                   tx = session.BeginTransaction();
                   c.Data = System.DateTime.Now;
                   if (c.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                     session.Save(c);
                   else
                     session.Update(c);
                   
                   tx.Commit();


                   
               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   throw new Exception("ControlPagament.cs:No s'ha pogut guardar el pagament: " + ex.ToString());
                   
               }
               
               return res;
           }


           //*********************************Esborra de la BD el pagament*********************************    
           public bool deletePagament(Pagament c)
           {
               bool res = true;
               ITransaction tx = null;
               try
               {

                   tx = session.BeginTransaction();
                   session.Delete(c);
                   tx.Commit();

               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
                   throw new Exception("ControlPagament.cs:No s'ha pogut esborrar el pagament " + ex.ToString());

               }

               return res;
           }


       //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
       public static ControlPagament getInstance()
       {
           if (_instance == null) { _instance = new ControlPagament(); }
           return _instance;
       }

       }
     
       
    }


