/******************************
 * Hereta de Controlador
 * ****************************/

using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller
{
   public  class ControlProducte : Controlador
    {
       static private ControlProducte _instance;
       

        //*********************************Obtencio de tots els productes de la BD*********************************      
       public IList loadProductes()
       {
           IList productes = null;

           try
           {   
              // productes = session.CreateCriteria(typeof(Producte)).List();
               productes = session.Find("from PFC.Producte as p where p.Disponible=1 order by p.Nom");

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlProducte.cs:No s'han pogut carregar el Productes :" + ex.Message);

           }
          
           return productes;
       }


       //*********************************Obtencio de tots els productes de un grup*********************************      
       public IList loadProductes(GrupProducte grup)
       {
           IList productes = null;

           try
           {
               // productes = session.CreateCriteria(typeof(Producte)).List();
               productes = session.Find("from PFC.Producte as p where p.Disponible=1 and p.Grup.Id="+grup.Id+" order by p.Nom");

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlProducte.cs:No s'han pogut carregar el Productes :" + ex.Message);

           }

           return productes;
       }
       //*********************************Obtenci de producte segons el seu Id*********************************
       public Producte loadProducte(int id)
       {
           Producte producte = null;
          
           try
           {
              producte = (Producte)session.Load(typeof(Producte), id);
             
               session.Refresh(producte);
           }
           catch (HibernateException ex)
           {
               throw new Exception("ControlProducte.cs:No s'ha pogut carregar el Producte "+id+":" + ex.Message);
           }

           return producte;
       }

       //*********************************Obtenci de  producte segons el seu nom*********************************
       public Producte loadProducte(string s)
       {
           Producte prod = null;
           IList i = null;

           try
           {
              
               i = session.Find("from PFC.Producte as g where g.Nom='" + s + "'");
               foreach (Producte p in i)
                   prod = p;
               if(prod!=null)
               session.Refresh(prod);
           }
           catch (HibernateException ex)
           {
               throw new Exception("ControlProducte.cs:No s'ha pogut carregar el Producte " + s + ": " + ex.Message);
           }

           return prod;
       }


       //*********************************Guarda a la BD el producte passat per parmetre*********************************      
       public bool saveProducte(Producte g)
       {
           ITransaction tx = null;
               bool res = true;
               
               try
               {
                  
                   tx = session.BeginTransaction();
                   if (g.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                   {
                       g.Disponible = true;
                       session.Save(g);
                   }
                   else
                   {
                       session.Update(g);
                   }
                   tx.Commit();


                   
               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   throw new Exception("ControlProducte.cs:No s'ha pogut guardar el Producte: " + ex.Message);
                   
               }
               
               return res;
           }

           //*********************************Esborra de la BD el producte*********************************    
           public bool deleteProducte(Producte g)
           {
               bool res = true;
               ITransaction tx = null;

               
               try
               {

                   tx = session.BeginTransaction();
                   session.Delete(g);
                   tx.Commit();

               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
                   res = false;
                   throw new Exception("ControlProducte.cs:No s'ha pogut esborrar el Producte " + ex.ToString());
                 //  MessageBox.Show("ControlProducte.cs:No s'ha pogut esborrar el Producte " + ex.ToString());


               }

               return res;
           }

       //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
       public static ControlProducte getInstance()
       {
           if (_instance == null) { _instance = new ControlProducte(); }
           return _instance;
       }

       }
     
       
    }


