/******************************
 * Hereta de Controlador
 * ****************************/

using System;
using System.Collections;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller
{
   public  class ControlTaula : Controlador
    {
       static private ControlTaula _instance;

        //*********************************Obtencio de totes les taules de la BD*********************************      
       public IList loadTaules()
       {
           IList taules = null;

           try
           {
               ReconnectSession();
              // taules = session.CreateCriteria(typeof(Taula)).List();
               taules = session.Find("from PFC.Taula where Activa=1");

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlTaula.cs:Error Carregant taules: " + ex.ToString());

           }

           return taules;
       }


       //*********************************Obtenci de taula segons el seu Id*********************************
       public Taula loadTaula(int id)
       {
           Taula taula = null;

           try
           {
               taula = (Taula)session.Load(typeof(Taula), id);
               session.Refresh(taula);
           }
           catch (HibernateException ex)
           {
               throw new Exception("ControlTaula.cs:No s'ha pogut carregar la Taula: " + ex.ToString());
           }

           return taula;
       }

       //*********************************Obtenci de taula segons el seu nom*********************************
       public Taula loadTaula(string s)
       {
           Taula taula = null;
           IList i = null;

           try
           {
               
               i = session.Find("from PFC.Taula as t where t.Nom='" + s + "'");
               foreach (Taula t in i)
                   taula = t;

               session.Refresh(taula);
           }
           catch (HibernateException ex)
           {
               throw new Exception("ControlTaula.cs:No s'ha pogut carregar la Taula " + s + ": " + ex.Message);
           }

           return taula;
       }

       //*********************************Guarda a la BD la taula passada per parmetre*********************************      
       public bool saveTaula(Taula c)
       {
           ITransaction tx = null;
               bool res = true;
               
               try
               {
                  
                   tx = session.BeginTransaction();
                   if (c.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                   {
                       c.Activa = true;
                       session.Save(c);

                   }
                   else
                   {
                       session.Update(c);
                   }
                   tx.Commit();

                   
               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   throw new Exception("ControlTaula.cs:No s'ha pogut guardar la taula: " + ex.ToString());
                  
               }
               
               return res;
           }

           //*********************************Esborra de la BD la taula*********************************    
           public bool deleteTaula(Taula t)
           {
               bool res = true;
               ITransaction tx = null;
               try
               {

                   tx = session.BeginTransaction();
                   session.Delete(t);
                   tx.Commit();

               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
                   throw new Exception("ControlTaula.cs:No s'ha pogut esborrar la Taula " + ex.ToString());

               }

               return res;
           }

       //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
       public static ControlTaula getInstance()
       {
           if (_instance == null) { _instance = new ControlTaula(); }
           return _instance;
       }

       }
     
       
    }


