/******************************
 * Hereta de Controlador
 * ****************************/

using System;
using System.Collections;
using System.Text;
using NHibernate;
using NHibernate.Cfg;
using System.Windows.Forms;
using NHibernate.Expression;
using NHibernate.Id;


namespace PFC.Controller
{
   public  class ControlTipusPagament : Controlador
    {
       static private ControlTipusPagament _instance;

      
       
       //*********************************Obtencio de tots els pagaments de la BD*********************************      
       public IList loadTipusPagaments()
       {
           IList pagaments = null;

           try
           {
               ReconnectSession();
              pagaments = session.CreateCriteria(typeof(TipusPagament)).List();

           }
           catch (HibernateException ex)
           {

               throw new Exception("ControlTipusPagament.cs:Error Carregant pagaments: " + ex.ToString());

           }

           return pagaments;
       }


       public TipusPagament loadTipusPagament(int id)
       {
           TipusPagament tipus = null;

           try
           {
               tipus = (TipusPagament)session.Load(typeof(TipusPagament), id);

               session.Refresh(tipus);
           }
           catch (HibernateException ex)
           {
               throw new Exception("ControlTipusPagament.cs:No s'ha pogut carregar la comanda " + id + ":" + ex.Message);
           }

           return tipus;
       }

       //*********************************Guarda a la BD el pagament passat per parmetre*********************************      
       public bool saveTipusPagament(TipusPagament c)
       {
           ITransaction tx = null;
               bool res = true;
               
               try
               {
                  
                   tx = session.BeginTransaction();
                   
                   if (c.Id == 0) //Valor de unsaved-value !!Abans d'estar guardat t el 0
                     session.Save(c);
                   else
                     session.Update(c);
                   
                   tx.Commit();


                   
               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   throw new Exception("ControlTipusPagament.cs:No s'ha pogut guardar el pagament: " + ex.ToString());
                   
               }
               
               return res;
           }


           //*********************************Esborra de la BD el pagament*********************************    
           public bool deleteTipusPagament(TipusPagament c)
           {
               bool res = true;
               ITransaction tx = null;
               try
               {

                   tx = session.BeginTransaction();
                   session.Delete(c);
                   tx.Commit();

               }
               catch (HibernateException ex)
               {
                   tx.Rollback();
                   res = false;
                   session.Clear(); //Neteja els possibles save,update i delete pendents per causa d'algun error
                   throw new Exception("ControlTipusPagament.cs:No s'ha pogut esborrar el pagament " + ex.ToString());

               }

               return res;
           }


       //*********************************Patr singleton:Obtenci sempre de la mateixa instancia*********************************      
       public static ControlTipusPagament getInstance()
       {
           if (_instance == null) { _instance = new ControlTipusPagament(); }
           return _instance;
       }

       }
     
       
    }


