using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PFC.Aplicacio_;
using System.Collections;
using System.IO;
using Heelana;


namespace PFC
{
    public partial class administracio : Form
    {
        AplicacioAdministracio aplicacio;
        Settings settings; //Opcions que aniran a un fitxer xml (simulant un .ini)
        
        ConfigConnexio connexio;
        
        public administracio()
        {
            InitializeComponent();
            aplicacio = new AplicacioAdministracio();
            aplicacio.IniciarAplicacio(); //Prepara la configuraci de hibernate i obre sessi
                      
            connexio = new ConfigConnexio();
        }

//Carreguem tots els datagrids amb les dades de la BD
        private void administracio_Load_1(object sender, EventArgs e)
        {            
            //Carreguem tot el que tenim a la BD en cada grid corresponent
            carregaFamiliesProductes();
            carregaProductes();
            carregaCambrers();
            carregaTaules();
            carregaNotes();
            carregaCobrosPendents();
            carregaCobros(aplicacio.obtenirPagaments());
            carregaTipusPagament();
            carregaFormesPagament();

           

              AplicacioPrincipal apl = new AplicacioPrincipal();
             // LogginCambrer loggin = new LogginCambrer(apl);
            LogginCambrer_PDA loggin = new LogginCambrer_PDA(apl);
              loggin.ShowDialog();
            
        }

        //Utilitzats per carregar els datagrids de elements de la BD i per refrescar-los
        private void carregaFamiliesProductes()
        {
         
            dataGridView1.Rows.Clear();//Eliminem tot el que hi ha primer..
            IList i = aplicacio.obtenirGrupsProductes();
            foreach (GrupProducte g in i)
                dataGridView1.Rows.Add(g.Id, g.Nom,g.Enviar_a);
            if (dataGridView1.Rows.Count == 0)
            {
                toolStripButton2Familia.Enabled = false;
                toolStripButton3Familia.Enabled = false;
            }
        }

        private void carregaProductes()
        {
            
            dataGridView2.Rows.Clear();
            IList i = aplicacio.obtenirProductes();
            foreach (Producte p in i)
                dataGridView2.Rows.Add(p.Id, p.Nom, p.Preu, p.Grup.Nom);
            if (dataGridView2.Rows.Count == 0)
            {
                toolStripButton2Producte.Enabled = false;
                toolStripButton3Producte.Enabled = false;
            }
        }

        private void carregaCambrers()
        {

            dataGridView3.Rows.Clear();
            IList i = aplicacio.obtenirCambrers();
            foreach (Cambrer p in i)
                dataGridView3.Rows.Add(p.Id, p.Nom, p.Cognoms, p.Password);
            if (dataGridView3.Rows.Count == 0)
            {
                toolStripButton2Personal.Enabled = false;
                toolStripButton3Personal.Enabled = false;
            }
        }


        private void carregaTaules()
        {
              dataGridView4.Rows.Clear();
            IList i = aplicacio.obtenirTaules();
            foreach (Taula t in i)
                dataGridView4.Rows.Add(t.Id, t.Nom);
            if (dataGridView4.Rows.Count == 0)
            {
                toolStripButton2Taula.Enabled = false;
                toolStripButton3Taula.Enabled = false;
            }
        }


        private void carregaNotes()
        {
            dataGridView5.Rows.Clear();
            IList i = aplicacio.obtenirNotes();
            foreach (NotesAdicionals n in i)
                dataGridView5.Rows.Add(n.Id, n.Descripcio, n.Grup.Nom);
            if (dataGridView5.Rows.Count == 0)
            {
                toolStripButton2Notes.Enabled = false;
                toolStripButton3Notes.Enabled = false;
            }
        }

        private void carregaCobrosPendents()
        {
            dataGridCobrosPendents.Rows.Clear();
            IList i = aplicacio.obtenirComandesNoPagades();
            foreach (Comanda c in i)
                dataGridCobrosPendents.Rows.Add(c.Id, c.Data, c.Preu,c.PreuModificat);
            
        }

        private void carregaCobros(IList i)
        {
            dataGridCobros.Rows.Clear();
           // IList i = aplicacio.obtenirPagaments();
            foreach (Pagament p in i)
                dataGridCobros.Rows.Add(p.Id,p.TipusPagament.Descripcio,p.Data,p.Import);

        }

        private void carregaTipusPagament()
        {
            IList i = aplicacio.obtenirTipusPagaments();
            foreach(TipusPagament t in i)
            comboFiltre1.Items.Add(t.Id+"-"+t.Descripcio);
        }

        

        private void carregaFormesPagament()
        {
            dataGridView11.Rows.Clear();
            IList i = aplicacio.obtenirTipusPagaments();
            foreach (TipusPagament n in i)
                dataGridView11.Rows.Add(n.Id, n.Descripcio);
            if (dataGridView11.Rows.Count == 0)
            {
                toolStripButton2FormesPagament.Enabled = false;
                toolStripButton3FormesPagament.Enabled = false;
            }
        }
/*****************************************************************************
 **GESTI DE FAMILIA DE PRODUCTES*
 *******************************************************************************/

       

   /*********2 maneres diferents d'eliminar*****/
        //Elimina la familia de la fila actual
        private void dataGridView1_UserDeletingRow(object sender, DataGridViewRowCancelEventArgs e)
        {
            e.Cancel=true;
            toolStripButton3Familia_Click(sender, new EventArgs());

        }

        //Bot de eliminar familia producte
        private void toolStripButton3Familia_Click(object sender, EventArgs e)
        {
            DialogResult d = MessageBox.Show("Estas segur que vols eliminar la familia?", "Confirmaci", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (d.ToString().Equals("OK"))
            {
                DataGridViewRow r = dataGridView1.CurrentRow;
                GrupProducte g =aplicacio.obtenirGrupProducte((Int32)r.Cells["column1"].Value);
                aplicacio.eliminarGrupProducte(g); //Elimina de la BD
               
                if (dataGridView1.Rows.Count-1 == 0)
                {
                    toolStripButton2Familia.Enabled = false;
                    toolStripButton3Familia.Enabled = false;
                }
                
                carregaFamiliesProductes();
                carregaProductes();
            }

        }

  /********3 events per anar a fitxa de modificacio de 4 maneres de diferents(3events+1bot)*****/
        private void preparaFitxaModificacio()
        {
            dataGridView1.Visible = false;
            toolStripButton3Familia.Enabled = false;
            textBox3Familia.Clear();
            textBox1Familia.Visible = true;
            textBox2Familia.Focus();
            DataGridViewRow r = dataGridView1.CurrentRow;
            textBox1Familia.Text = Convert.ToString( (Int32)r.Cells["column1"].Value);
            textBox2Familia.Text = (string)r.Cells["column2"].Value;
            label1.Visible = true;
            label3.Text = "Modificaci de Familia producte";
            if (File.Exists(aplicacio.rutaImatges + textBox2Familia.Text + ".jpg")) //Si te una imatge la carguem al seu textbox
                textBox3Familia.Text = aplicacio.rutaImatges + textBox2Familia.Text + ".jpg";

            comboBox3.Text = (string)r.Cells["column3"].Value;
        }
        
        //Modificaci fila actual
        private void dataGridView1_RowHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            preparaFitxaModificacio();
            
        }

           
        //Modificaci fila actual
        private void dataGridView1_CellMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.dataGridView1_RowHeaderMouseDoubleClick(sender, e);
        }

        //Modificaci fila actual
        private void dataGridView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.ToString().Equals("Return"))
            {
                preparaFitxaModificacio();
            }

        }
               
        //Boto de modificaci Familia
        private void toolStripButton2Familia_Click(object sender, EventArgs e)
        {
            preparaFitxaModificacio();
        }


        //Boto de nova Familia
        private void toolStripButton1Familia_Click(object sender, EventArgs e)
        {
            dataGridView1.Visible = false;
            toolStripButton2Familia.Enabled = false;
            toolStripButton3Familia.Enabled = false;
            textBox2Familia.Focus();
            label3.Text = "Nova Familia de productes";
            label1.Visible = false;
            textBox1Familia.Visible = false;
            textBox2Familia.Clear();
            textBox3Familia.Clear();
            comboBox3.Text = "";
        }


        //Bot de confirmacio guardar/Modificar familia producte (dins de la fitxa)
        private void button1_Click(object sender, EventArgs e)
        {
            GrupProducte g = new GrupProducte();
           
            if (textBox2Familia.Text != "")
            {
            
            if (textBox1Familia.Visible) //Si l'etiqueta Id es visible estem en mode modificaci
            {
                
                     g = aplicacio.obtenirGrupProducte(Convert.ToInt32(textBox1Familia.Text));
                  if (textBox3Familia.Text == "")//Si el camp est buit,pot ser que vulguem eliminar la imatge
                     {
                         if (File.Exists(aplicacio.rutaImatges + textBox2Familia.Text + ".jpg"))
                             File.Delete(aplicacio.rutaImatges + textBox2Familia.Text + ".jpg");
                     }
              


            }
            else //EStem en mode Nova Familia
            {
                 g = new GrupProducte();
                
            }

            //Agafar la imatge obtenida al openDialog i la copiarem a la carpeta de imatges del programa
            String rutaFinal = aplicacio.rutaImatges + textBox2Familia.Text.ToUpper() + ".jpg";
            aplicacio.guardaImatge(textBox3Familia.Text, rutaFinal);
            if ((g.Nom != textBox2Familia.Text)&&(rutaFinal.ToUpper()!= textBox3Familia.Text.ToUpper())&&(textBox3Familia.Text!=""))//Si s'ha cambiat el nom de la familia
                File.Delete(textBox3Familia.Text);

            g.Nom = textBox2Familia.Text;
            g.Enviar_a = comboBox3.Text;
            aplicacio.guardarGrupProducte(g); //Modificara o guardar a la BD

            carregaFamiliesProductes();
            carregaProductes();
            dataGridView1.Visible = true;
            toolStripButton2Familia.Enabled = true;
            toolStripButton3Familia.Enabled = true;
        }
        else MessageBox.Show("Introdueix algun nom a la familia de productes", "Entrada invlida", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            

        }

        //Bot de cancelar, simplement retorna al datagrid..
        private void button3_Click(object sender, EventArgs e)
        {
            dataGridView1.Visible = true;
            
            textBox1Familia.Visible = true;
            
            toolStripButton2Familia.Enabled = true;
            toolStripButton3Familia.Enabled = true;
            
        }


        //But per carregar una imatge
        private void button9_Click(object sender, EventArgs e)
        {

            openFileDialog1.Filter = "Imatges(*.bmp;*.jpg;*.gif)|*.bmp;*.jpg;*.gif";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
                textBox3Familia.Text = openFileDialog1.FileName;

        }

        //Escollim a on s'enviarn les linees de comanda d'aquesta familia de productes
        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            String s = (String)comboBox3.SelectedItem;
            comboBox3.Text = s;
        }



/*****************************************************************************
***GESTI DELS PRODUCTES*
******************************************************************************/

        /*********2 maneres diferents d'eliminar*****/
        //Elimina el producte de la fila actual
        private void dataGridView2_UserDeletingRow(object sender, DataGridViewRowCancelEventArgs e)
        {
            e.Cancel = true;
            toolStripButton3Producte_Click(sender, new EventArgs());

        }

        //Bot de eliminar producte
        private void toolStripButton3Producte_Click(object sender, EventArgs e)
        {
            DialogResult d = MessageBox.Show("Estas segur que vols eliminar el producte?", "Confirmaci", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (d.ToString().Equals("OK"))
            {
                DataGridViewRow r = dataGridView2.CurrentRow;
                Producte p = aplicacio.obtenirProducte((Int32)r.Cells["column21"].Value);
                aplicacio.eliminarProducte(p); //Elimina de la BD

                
                if (dataGridView2.Rows.Count-1 == 0)
                {
                    toolStripButton2Producte.Enabled = false;
                    toolStripButton3Producte.Enabled = false;
                }
                carregaProductes();
            }

        }

        /********3 events per anar a fitxa de modificacio de 4 maneres de diferents(3events+1bot)*****/
        private void preparaFitxaModificacioProducte()
        {
            dataGridView2.Visible = false;
            toolStripButton3Producte.Enabled = false;
            textBox2Producte.Focus();
            textBox4Producte.Clear();
            DataGridViewRow r = dataGridView2.CurrentRow;
            textBox1Producte.Text = Convert.ToString( (Int32)r.Cells["Column21"].Value);
            textBox2Producte.Text = (string)r.Cells["Column22"].Value;
            textBox3Producte.Text = Convert.ToString( (decimal)r.Cells["Column23"].Value);
            label9.Visible = true;  //Etiqueta Id
            textBox1Producte.Visible = true;
            label7.Text = "Modificaci de producte";

            comboBox1.Items.Clear();//borrem i tornem a carregar per si hi ha hagut cambis
            IList i = aplicacio.obtenirGrupsProductes();
            foreach (GrupProducte g in i)
                comboBox1.Items.Add(g.Nom);
            comboBox1.Text = (String)r.Cells["Column24"].Value;

            if (File.Exists(aplicacio.rutaImatges + textBox2Producte.Text + ".jpg")) //Si te una imatge la carguem al seu textbox
                textBox4Producte.Text = aplicacio.rutaImatges + textBox2Producte.Text + ".jpg";
        }

        //Modificaci fila actual
        private void dataGridView2_RowHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            preparaFitxaModificacioProducte();

        }


        //Modificaci fila actual
        private void dataGridView2_CellMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.dataGridView2_RowHeaderMouseDoubleClick(sender, e);
        }

        //Modificaci fila actual
        private void dataGridView2_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.ToString().Equals("Return"))
            {
                preparaFitxaModificacioProducte();
            }

        }

        //Boto de modificaci producte
        private void toolStripButton2Producte_Click(object sender, EventArgs e)
        {
            preparaFitxaModificacioProducte();
        }

        //Boto de nou Producte
        private void toolStripButton1Producte_Click(object sender, EventArgs e)
        {
            dataGridView2.Visible = false;
            toolStripButton2Producte.Enabled = false;
            toolStripButton3Producte.Enabled = false;
            textBox2Producte.Focus();
            label7.Text = "Nou producte";
            label9.Visible = false;  //Etiqueta Id
            textBox1Producte.Visible = false;
            textBox2Producte.Clear();
            textBox3Producte.Clear();
            comboBox1.Text = "";
        
            comboBox1.Items.Clear();//borrem i tornem a carregar per si hi ha hagut cambis
            IList i = aplicacio.obtenirGrupsProductes();
            foreach (GrupProducte g in i)
                comboBox1.Items.Add(g.Nom);

            textBox4Producte.Text = "";

        }


        //Bot de cancelar, simplement retorna al datagrid..
       
        private void button4_Click_1(object sender, EventArgs e)
        {
            dataGridView2.Visible = true;
            textBox1Producte.Visible = true;
            toolStripButton2Producte.Enabled = true;
            toolStripButton3Producte.Enabled = true;

        }

        //Bot de confirmacio guardar/Modificar  producte (dins de la fitxa)
        private void button5_Click_1(object sender, EventArgs e)
        {
            if ((textBox2Producte.Text != "")&&(textBox3Producte.Text!="")&&(comboBox1.Text!=""))
            {
                Producte p = null;
                if (textBox1Producte.Visible) //Si l'etiqueta Id es visible estem en mode modificaci
                {

                     p = aplicacio.obtenirProducte(Convert.ToInt32(textBox1Producte.Text));
                     if (textBox4Producte.Text == "")//Si el camp est buit,pot ser que vulguem eliminar la imatge
                     {
                         if (File.Exists(aplicacio.rutaImatges + textBox2Producte.Text + ".jpg"))
                             File.Delete(aplicacio.rutaImatges + textBox2Producte.Text + ".jpg");
                     }
                   
                }
                else //EStem en mode Nou Producte
                {
                   p = new Producte();
                   
                }
                //Agafar la imatge obtenida al openDialog i la copiarem a la carpeta de imatges del programa
                String rutaFinal = aplicacio.rutaImatges + textBox2Producte.Text.ToUpper() + ".jpg";
                aplicacio.guardaImatge(textBox4Producte.Text, rutaFinal);
                if ((p.Nom != textBox2Producte.Text) && (rutaFinal.ToUpper() != textBox4Producte.Text.ToUpper())&&(textBox4Producte.Text!=""))//Si s'ha cambiat el nom de el producte
                    File.Delete(textBox4Producte.Text);
                

                p.Nom = textBox2Producte.Text;

                String preu= textBox3Producte.Text.Replace('.', ','); //Reemplacem els . per ,
                try
                {
                    p.Preu = Convert.ToDecimal(preu);
                }
                catch (Exception) { MessageBox.Show("Format de preu incorrecte!,es posar a 0 per defecte", "Entrada invlida", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); }
                p.Grup = aplicacio.obtenirGrupProducte(comboBox1.Text);
                
                aplicacio.guardarProducte(p); //Modificara o guardara a la BD

               
                
                carregaProductes();
                dataGridView2.Visible = true;
                toolStripButton2Producte.Enabled = true;
                toolStripButton3Producte.Enabled = true;
            }
            else MessageBox.Show("No has completat correctament tots els camps", "Entrada invlida", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            

        }

              
        //Selecci de familia per un producte
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            String nomFamilia=(String)comboBox1.SelectedItem;
            comboBox1.Text = nomFamilia;
        }


        //But per carregar imatge al producte
        private void button8_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "Imatges(*.bmp;*.jpg;*.gif)|*.bmp;*.jpg;*.gif";
            openFileDialog1.Title = "";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
                textBox4Producte.Text = openFileDialog1.FileName;

        }





/*****************************************************************************
***GESTI DEL PERSONAL  
******************************************************************************/
       

        /*********2 maneres diferents d'eliminar*****/
        //Elimina el producte de la fila actual
        private void dataGridView3_UserDeletingRow_1(object sender, DataGridViewRowCancelEventArgs e)
        {
            e.Cancel = true;
            toolStripButton3Personal_Click(sender, new EventArgs());

        }

        //Bot de eliminar cambrer
        private void toolStripButton3Personal_Click(object sender, EventArgs e)
        {
            DialogResult d = MessageBox.Show("Estas segur que vols eliminar el cambrer?", "Confirmaci", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (d.ToString().Equals("OK"))
            {
                DataGridViewRow r = dataGridView3.CurrentRow;
                Cambrer p = aplicacio.obtenirCambrer((Int32)r.Cells["column31"].Value);
                aplicacio.eliminarCambrer(p); //Elimina de la BD


                if (dataGridView3.Rows.Count - 1 == 0)
                {
                    toolStripButton2Personal.Enabled = false;
                    toolStripButton3Personal.Enabled = false;
                }
                carregaCambrers();
            }

        }

        /********3 events per anar a fitxa de modificacio de 4 maneres de diferents(3events+1bot)*****/
        private void preparaFitxaModificacioPersonal()
        {
            dataGridView3.Visible = false;
            toolStripButton3Personal.Enabled = false;
            textBox2Personal.Focus();
            DataGridViewRow r = dataGridView3.CurrentRow;
            textBox1Personal.Text = Convert.ToString((Int32)r.Cells["Column31"].Value);
            textBox2Personal.Text = (string)r.Cells["Column32"].Value;
            textBox3Personal.Text = (string)r.Cells["Column33"].Value;
            textBox4Personal.Text = (string)r.Cells["Column34"].Value;
            label16.Visible = true;  //Etiqueta Id
            textBox1Personal.Visible = true;
            label4.Text = "Modificaci de personal";

        }

        //Modificaci fila actual
        private void dataGridView3_RowHeaderMouseDoubleClick_1(object sender, DataGridViewCellMouseEventArgs e)
        {
            preparaFitxaModificacioPersonal();

        }


        //Modificaci fila actual
        private void dataGridView3_CellMouseDoubleClick_1(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.dataGridView3_RowHeaderMouseDoubleClick_1(sender, e);
        }


        //Modificaci fila actual
        private void dataGridView3_KeyDown_1(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.ToString().Equals("Return"))
            {
                preparaFitxaModificacioPersonal();
            }

        }

        //Boto de modificaci Familia
        private void toolStripButton2Personal_Click(object sender, EventArgs e)
        {
            preparaFitxaModificacioPersonal();
        }

        //Boto de nou Producte
        private void toolStripButton1Personal_Click(object sender, EventArgs e)
        {
            dataGridView3.Visible = false;
            toolStripButton2Personal.Enabled = false;
            toolStripButton3Personal.Enabled = false;
            textBox2Personal.Focus();
            label14.Text = "Nou producte";
            label16.Visible = false;  //Etiqueta Id
            textBox1Personal.Visible = false;
            textBox2Personal.Clear();
            textBox3Personal.Clear();
            textBox4Personal.Clear();



        }


        //Bot de cancelar, simplement retorna al datagrid..

        private void button6_Click_1(object sender, EventArgs e)
        {
            dataGridView3.Visible = true;
            textBox1Personal.Visible = true;
            toolStripButton2Personal.Enabled = true;
            toolStripButton3Personal.Enabled = true;

        }

        //Bot de confirmacio guardar/Modificar personal (dins de la fitxa)
        private void button7_Click_1(object sender, EventArgs e)
        {
            if ((textBox2Personal.Text != "") && (textBox3Personal.Text != "") && (textBox4Personal.Text != ""))
            {
                Cambrer p = null;
                if (textBox1Personal.Visible) //Si l'etiqueta Id es visible estem en mode modificaci
                {

                    p = aplicacio.obtenirCambrer(Convert.ToInt32(textBox1Personal.Text));

                }
                else //EStem en mode Nou Producte
                {
                    p = new Cambrer();

                }

                p.Nom = textBox2Personal.Text;
                p.Cognoms = textBox3Personal.Text;
                p.Password = textBox4Personal.Text;

                aplicacio.guardarCambrer(p); //Modificara o guardara a la BD

               
                
                carregaCambrers();
                dataGridView3.Visible = true;
                toolStripButton2Personal.Enabled = true;
                toolStripButton3Personal.Enabled = true;
            }
            else MessageBox.Show("No has completat correctament tots els camps", "Entrada invlida", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);


        }

        //Funcio per fer un refresh a tots els datagrid
        private void tabControl1_KeyDown(object sender, KeyEventArgs e)
        {
            
            if (e.KeyCode.ToString().Equals("F5"))
            {
                carregaCambrers();
                carregaFamiliesProductes();
                carregaProductes();
            }

        }











//***************CONFIGURACIONS DEL SISTEMA*************************//

        
        private void connexiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            connexio.ShowDialog();
        }









/*****************************************************************************
***GESTI DE LES TAULES  
******************************************************************************/



        /*********2 maneres diferents d'eliminar*****/
        //Elimina la taula de la fila actual
        private void dataGridView4_UserDeletingRow(object sender, DataGridViewRowCancelEventArgs e)
        {
            e.Cancel = true;
            toolStripButton3Taula_Click_1(sender, new EventArgs());

        }

        //Bot de eliminar taula 
        private void toolStripButton3Taula_Click_1(object sender, EventArgs e)
        {
            DialogResult d = MessageBox.Show("Estas segur que vols eliminar la taula?", "Confirmaci", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (d.ToString().Equals("OK"))
            {
                DataGridViewRow r = dataGridView4.CurrentRow;
                Taula g = aplicacio.obtenirTaula((Int32)r.Cells["Column41"].Value);
                aplicacio.eliminarTaula(g); //Elimina de la BD

                if (dataGridView4.Rows.Count - 1 == 0)
                {
                    toolStripButton2Taula.Enabled = false;
                    toolStripButton3Taula.Enabled = false;
                }

                carregaTaules();
              
            }

        }

        /********3 events per anar a fitxa de modificacio de 4 maneres de diferents(3events+1bot)*****/
        private void preparaFitxaModificacioTaula()
        {
            dataGridView4.Visible = false;
            toolStripButton3Taula.Enabled = false;
           
            textBox1Taula.Visible = true;
            textBox2Taula.Focus();
            DataGridViewRow r = dataGridView4.CurrentRow;
            textBox1Taula.Text = Convert.ToString((Int32)r.Cells["Column41"].Value);
            textBox2Taula.Text = (string)r.Cells["column42"].Value;
            label22.Visible = true;
            label20.Text = "Modificaci de Taula";
            


        }

        //Modificaci fila actual
        private void dataGridView4_RowHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            preparaFitxaModificacioTaula();

        }


        //Modificaci fila actual
        
        private void dataGridView4_CellMouseDoubleClick_1(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.dataGridView4_RowHeaderMouseDoubleClick(sender, e);
        }


        //Modificaci fila actual
        private void dataGridView4_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.ToString().Equals("Return"))
            {
                preparaFitxaModificacioTaula();
            }

        }

        //Boto de modificaci Taula
        private void toolStripButton2Taula_Click_1(object sender, EventArgs e)
        {
            preparaFitxaModificacioTaula();
        }

        //Boto de nova Taula
        private void toolStripButton1Taula_Click_1(object sender, EventArgs e)
        {
            dataGridView4.Visible = false;
            toolStripButton2Taula.Enabled = false;
            toolStripButton3Taula.Enabled = false;
            textBox2Taula.Focus();
            label20.Text = "Nova Taula";
            label22.Visible = false;
            textBox1Taula.Visible = false;
            textBox2Taula.Clear();
            

        }


        //Bot de confirmacio guardar/Modificar taula (dins de la fitxa)
        private void button12_Click(object sender, EventArgs e)
        {
            Taula g = new Taula();

            if (textBox2Taula.Text != "")
            {

                if (textBox1Taula.Visible) //Si l'etiqueta Id es visible estem en mode modificaci
                {

                    g = aplicacio.obtenirTaula(Convert.ToInt32(textBox1Taula.Text));
                    

                }
                else //EStem en mode Nova taula
                {
                    g = new Taula();

                }

                g.Nom = textBox2Taula.Text;
                aplicacio.guardarTaula(g); //Modificara o guardar a la BD
                carregaTaules();
                dataGridView4.Visible = true;
                toolStripButton2Taula.Enabled = true;
                toolStripButton3Taula.Enabled = true;
            }
            else MessageBox.Show("Introdueix algun nom a la taula", "Entrada invlida", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);


        }

        //Bot de cancelar, simplement retorna al datagrid..
        private void button11_Click(object sender, EventArgs e)
        {
            dataGridView4.Visible = true;

            textBox1Taula.Visible = true;

            toolStripButton2Taula.Enabled = true;
            toolStripButton3Taula.Enabled = true;

        }






/*****************************************************************************
***GESTI DE LES NOTES ADICIONALS  
******************************************************************************/



        /*********2 maneres diferents d'eliminar*****/
        //Elimina la nota de la fila actual
        private void dataGridView5_UserDeletingRow(object sender, DataGridViewRowCancelEventArgs e)
        {
            e.Cancel = true;
            toolStripButton3Notes_Click(sender, new EventArgs());

        }

        //Bot de eliminar nota 
        private void toolStripButton3Notes_Click(object sender, EventArgs e)
        {
            DialogResult d = MessageBox.Show("Estas segur que vols eliminar la nota?", "Confirmaci", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (d.ToString().Equals("OK"))
            {
                DataGridViewRow r = dataGridView5.CurrentRow;
                NotesAdicionals n = aplicacio.obtenirNota((Int32)r.Cells["Column51"].Value);
                aplicacio.eliminarNota(n); //Elimina de la BD

                if (dataGridView5.Rows.Count - 1 == 0)
                {
                    toolStripButton2Notes.Enabled = false;
                    toolStripButton3Notes.Enabled = false;
                }

                carregaNotes();

            }

        }

        /********3 events per anar a fitxa de modificacio de 4 maneres de diferents(3events+1bot)*****/
        private void preparaFitxaModificacioNotes()
        {
            dataGridView5.Visible = false;
            toolStripButton3Notes.Enabled = false;

            textBox1Notes.Visible = true;
            textBox2Notes.Focus();
            DataGridViewRow r = dataGridView5.CurrentRow;
            textBox1Notes.Text = Convert.ToString((Int32)r.Cells["Column51"].Value);
            textBox2Notes.Text = (string)r.Cells["column52"].Value;
            label24.Visible = true;
            label19.Text = "Modificaci de Nota";

            comboBox2.Items.Clear();//borrem i tornem a carregar per si hi ha hagut cambis
            IList i = aplicacio.obtenirGrupsProductes();
            foreach (GrupProducte g in i)
                comboBox2.Items.Add(g.Nom);
            comboBox2.Text = (String)r.Cells["Column53"].Value;



        }

        //Modificaci fila actual
        private void dataGridView5_RowHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            preparaFitxaModificacioNotes();

        }


        //Modificaci fila actual

        private void dataGridView5_CellMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.dataGridView5_RowHeaderMouseDoubleClick(sender, e);
        }


        //Modificaci fila actual
        private void dataGridView5_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.ToString().Equals("Return"))
            {
                preparaFitxaModificacioNotes();
            }

        }

        //Boto de modificaci nota
        private void toolStripButton2Notes_Click(object sender, EventArgs e)
        {
            preparaFitxaModificacioNotes();
        }

        //Boto de nova nota
        private void toolStripButton1Notes_Click(object sender, EventArgs e)
        {
            dataGridView5.Visible = false;
            toolStripButton2Notes.Enabled = false;
            toolStripButton3Notes.Enabled = false;
            textBox2Notes.Focus();
            label19.Text = "Nova Nota";
            label24.Visible = false;
            textBox1Notes.Visible = false;
            textBox2Notes.Clear();

            comboBox2.Text = "";

            comboBox2.Items.Clear();//borrem i tornem a carregar per si hi ha hagut cambis
            IList i = aplicacio.obtenirGrupsProductes();
            foreach (GrupProducte g in i)
                comboBox2.Items.Add(g.Nom);

        }


        //Bot de confirmacio guardar/Modificar nota (dins de la fitxa)
        private void button13_Click(object sender, EventArgs e)
        {
            NotesAdicionals g = new NotesAdicionals();

            if (textBox2Notes.Text != "")
            {

                if (textBox1Notes.Visible) //Si l'etiqueta Id es visible estem en mode modificaci
                {

                    g = aplicacio.obtenirNota(Convert.ToInt32(textBox1Notes.Text));


                }
                else //EStem en mode Nova taula
                {
                    g = new NotesAdicionals();

                }

                g.Descripcio = textBox2Notes.Text;
                g.Grup = aplicacio.obtenirGrupProducte(comboBox2.Text);
                aplicacio.guardarNota(g); //Modificara o guardar a la BD
                carregaNotes();
                dataGridView5.Visible = true;
                toolStripButton2Notes.Enabled = true;
                toolStripButton3Notes.Enabled = true;
            }
            else MessageBox.Show("Introdueix alguna descripci a la nota", "Entrada invlida", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);


        }

        //Bot de cancelar, simplement retorna al datagrid..
        
        private void button10_Click_1(object sender, EventArgs e)
        {
            dataGridView5.Visible = true;

            textBox1Notes.Visible = true;

            toolStripButton2Notes.Enabled = true;
            toolStripButton3Notes.Enabled = true;

        }

        
         //Selecci de familia per un producte
        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            String nomFamilia=(String)comboBox2.SelectedItem;
            comboBox2.Text = nomFamilia;
        }




/*****************************************************************************
***GESTI DE FORMES DE PAGAMENT  
******************************************************************************/
        /*********2 maneres diferents d'eliminar*****/
        //Elimina la taula de la fila actual
        private void dataGridView11_UserDeletingRow(object sender, DataGridViewRowCancelEventArgs e)
        {
            e.Cancel = true;
            toolStripButton3FormesPagament_Click_1(sender, new EventArgs());

        }




        //Bot de eliminar taula 
        private void toolStripButton3FormesPagament_Click_1(object sender, EventArgs e)
        {
            DialogResult d = MessageBox.Show("Estas segur que vols eliminar la forma de pagament?", "Confirmaci", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);
            if (d.ToString().Equals("OK"))
            {
                DataGridViewRow r = dataGridView11.CurrentRow;
                TipusPagament t = aplicacio.obtenirTipusPagament((Int32)r.Cells["Column61"].Value);
                aplicacio.eliminarTipusPagament(t); //Elimina de la BD

                if (dataGridView11.Rows.Count - 1 == 0)
                {
                    toolStripButton2FormesPagament.Enabled = false;
                    toolStripButton3FormesPagament.Enabled = false;
                }

                carregaFormesPagament();

            }

        }

        /********3 events per anar a fitxa de modificacio de 4 maneres de diferents(3events+1bot)*****/
        private void preparaFitxaModificacioFormes()
        {
            dataGridView11.Visible = false;
            toolStripButton3FormesPagament.Enabled = false;

            textBox1Formes.Visible = true;
            textBox2Formes.Focus();
            DataGridViewRow r = dataGridView11.CurrentRow;
            textBox1Formes.Text = Convert.ToString((Int32)r.Cells["Column61"].Value);
            textBox2Formes.Text = (string)r.Cells["column62"].Value;
            label79.Visible = true;
            label77.Text = "Modificaci de Forma pagament";



        }

        //Modificaci fila actual
        private void dataGridView11_RowHeaderMouseDoubleClick_1(object sender, DataGridViewCellMouseEventArgs e)
        {
            preparaFitxaModificacioFormes();

        }


        //Modificaci fila actual

        private void dataGridView11_CellMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.dataGridView11_RowHeaderMouseDoubleClick_1(sender, e);
        }





        //Boto de modificaci Taula
        private void toolStripButton2FormesPagament_Click_1(object sender, EventArgs e)
        {
            preparaFitxaModificacioFormes();
        }

        //Boto de nova Taula
        private void toolStripButton1FormesPagament_Click_1(object sender, EventArgs e)
        {
            dataGridView11.Visible = false;
            toolStripButton2FormesPagament.Enabled = false;
            toolStripButton3FormesPagament.Enabled = false;
            textBox2Formes.Focus();
            label77.Text = "Nova forma pagament";
            label79.Visible = false;
            textBox1Formes.Visible = false;
            textBox2Formes.Clear();


        }


        //Bot de confirmacio guardar/Modificar taula (dins de la fitxa)
        private void button36_Click(object sender, EventArgs e)
        {
            TipusPagament t = new TipusPagament();

            if (textBox2Formes.Text != "")
            {

                if (textBox1Formes.Visible) //Si l'etiqueta Id es visible estem en mode modificaci
                {

                    t = aplicacio.obtenirTipusPagament(Convert.ToInt32(textBox1Formes.Text));


                }
                else //EStem en mode Nova forma pagament
                {
                    t = new TipusPagament();

                }

                t.Descripcio = textBox2Formes.Text;
                aplicacio.guardarTipusPagament(t); //Modificara o guardar a la BD
                carregaFormesPagament();
                dataGridView11.Visible = true;
                toolStripButton2FormesPagament.Enabled = true;
                toolStripButton3FormesPagament.Enabled = true;
            }
            else MessageBox.Show("Introdueix algun nom a la forma de pagament", "Entrada invlida", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);


        }

        //Bot de cancelar, simplement retorna al datagrid..
        private void button35_Click_1(object sender, EventArgs e)
        {
            dataGridView11.Visible = true;

            textBox1Formes.Visible = true;

            toolStripButton2FormesPagament.Enabled = true;
            toolStripButton3FormesPagament.Enabled = true;

        }

        






/****************************************************************************************************************************
*************************************GESTI DELS COBROS PENDENTS************************************************************
****************************************************************************************************************************/

       
        private void dataGridCobrosPendents_CellMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
             if (e.RowIndex != -1)
              {
                  decimal import = Convert.ToDecimal(dataGridCobrosPendents[2, e.RowIndex].Value);
                  decimal importEditat = Convert.ToDecimal(dataGridCobrosPendents[3, e.RowIndex].Value);
                  Cobrar cobrar;
                  AplicacioPrincipal apl = new AplicacioPrincipal();
                  Comanda comanda = apl.obtenirComanda(Convert.ToInt16(dataGridCobrosPendents[0, e.RowIndex].Value));
                  Pagament pagament = new Pagament();

                  if (importEditat != 0)
                  {
                      cobrar = new Cobrar(importEditat, apl);
                      pagament.Import = importEditat;
                  }
                  else
                  {
                      cobrar = new Cobrar(import, apl);
                      pagament.Import = import;
                  }
                  cobrar.ShowDialog();

                  //Un cop hem realitzat l'operaci
                  if (cobrar.cobrat != null)
                  {
                      if (cobrar.cobrat == "OK") //Ha estat pagat
                      {
                          pagament.Comanda = comanda;
                          pagament.TipusPagament = cobrar.tipus;
                          aplicacio.guardarPagament(pagament);
                          comanda.Estat = "Cobrada";
                          apl.guardarComanda(comanda);
                      }
                      carregaCobrosPendents();


                  }
              }
        }

        //Quan carreguem el tabCobros recarreguem tot altre cop
        private void tabControlCobros_MouseClick(object sender, MouseEventArgs e)
        {
            carregaCobros(aplicacio.obtenirPagaments());
            comboFiltre1.Text = "Tipus pagament";
            textBoxData1.Clear();
            textBoxData2.Clear();
        }


        //Filtratge per fer les totalitzacions
        int tipus = -1;
        String DataInici = "";
        String DataFinal = "";

        //Camp de data inicial a filtrar
        private void dateTimePicker1_ValueChanged(object sender, EventArgs e)
        {
            textBoxData1.Text = dateTimePicker1.Value.Day + "/" + dateTimePicker1.Value.Month + "/" + dateTimePicker1.Value.Year;
            DataInici = dateTimePicker1.Value.Year + "/" + dateTimePicker1.Value.Month + "/" + dateTimePicker1.Value.Day + " " + comboBox7.Text;
            carregaCobros(aplicacio.obtenirPagaments(tipus, DataInici, DataFinal));
        }

        private void dateTimePicker2_ValueChanged(object sender, EventArgs e)
        {
             textBoxData2.Text = dateTimePicker2.Value.Day + "/" + dateTimePicker2.Value.Month + "/" + dateTimePicker2.Value.Year;
             DataFinal = dateTimePicker2.Value.Year + "/" + dateTimePicker2.Value.Month + "/" + dateTimePicker2.Value.Day + " " + comboBox8.Text;
            carregaCobros(aplicacio.obtenirPagaments(tipus, DataInici, DataFinal));
        }

        //Camps per marcar les hores
        private void comboBox7_SelectedIndexChanged(object sender, EventArgs e)
        {
            String[] Data = DataInici.Split(' ');
            if (DataInici != "")
            {
                DataInici = Data[0] + " " + comboBox7.Text;
                carregaCobros(aplicacio.obtenirPagaments(tipus, DataInici, DataFinal));
            }
        }

        private void comboBox8_SelectedIndexChanged(object sender, EventArgs e)
        {
            String[] Data = DataFinal.Split(' ');
            if (DataFinal != "")
            {
                DataFinal = Data[0] + " " + comboBox8.Text;
                carregaCobros(aplicacio.obtenirPagaments(tipus, DataInici, DataFinal));
            }
        }

        //Camp de tipus pagament
        private void comboFiltre1_SelectedIndexChanged(object sender, EventArgs e)
        {
            tipus =Convert.ToInt16(comboFiltre1.Text.Substring(0, 1));
            carregaCobros(aplicacio.obtenirPagaments(tipus, DataInici, DataFinal));
        }
/***************** BOTONS DEL MEN I ACCESOS DIRECTES****************************************/

       

        //Boto sistema->familia
        private void familiaProductesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlSistema.Visible = true;
            tabControlSistema.BringToFront();
            tabControlSistema.SelectedIndex = 0;
        }

        //Boto sistema->productes
        private void productesToolStripMenuItem_Click(object sender, EventArgs e)
        {

            tabControlSistema.Visible = true;
            tabControlSistema.BringToFront();
            tabControlSistema.SelectedIndex = 2;
        }

        //Boto sistema->personal
        private void personalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlSistema.Visible = true;
            tabControlSistema.BringToFront();
            tabControlSistema.SelectedIndex = 1;
        }

        //Boto sistema->taules
        private void taulesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlSistema.Visible = true;
            tabControlSistema.BringToFront();
            tabControlSistema.SelectedIndex = 3;
        }

        //Boto sistema->notesAdicionals
        private void notesAdicionalsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlSistema.Visible = true;
            tabControlSistema.BringToFront();
            tabControlSistema.SelectedIndex = 4;
        }

        //Boto sistema->Formes de pagament
        private void formesDePagamentToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlSistema.Visible = true;
            tabControlSistema.BringToFront();
            tabControlSistema.SelectedIndex = 5;
        }


        //Boto menu Cobros->cobros pendents
        private void cobrosPendentsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlCobros.Visible = true;
            tabControlCobros.BringToFront();
            tabControlCobros.SelectedIndex = 0;
        }

        //Boto menu Cobros-> totalitzaci
        private void totalitzaciToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlCobros.Visible = true;
            tabControlCobros.BringToFront();
            tabControlCobros.SelectedIndex = 1;
        }

        //Aplicaci-->inici
        private void iniciToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlSistema.Visible = false;
            tabControlCobros.Visible = false;
        }

        //Aplicaci-->sortir
        private void sortirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

       //**********Accesos directes**************
        //Familia
        private void button26_Click(object sender, EventArgs e)
        {
            familiaProductesToolStripMenuItem_Click(new object(), new EventArgs());
        }
        //Productes
        private void button27_Click(object sender, EventArgs e)
        {
            productesToolStripMenuItem_Click(new object(), new EventArgs());
        }
        //Personal
        private void button28_Click(object sender, EventArgs e)
        {
           personalToolStripMenuItem_Click(new object(), new EventArgs());
        }
        //Taules
        private void button31_Click(object sender, EventArgs e)
        {
            taulesToolStripMenuItem_Click(new object(), new EventArgs());
        }
        //Notes adicionals
        private void button32_Click(object sender, EventArgs e)
        {
            notesAdicionalsToolStripMenuItem_Click(new object(), new EventArgs());
          
        }
        //Formes de pago
        private void button37_Click(object sender, EventArgs e)
        {
            formesDePagamentToolStripMenuItem_Click(new object(), new EventArgs());
        }

        //Cobros pendents
        private void button38_Click(object sender, EventArgs e)
        {
            cobrosPendentsToolStripMenuItem_Click(new object(), new EventArgs());
        }

              
        //Totalitzacio
        private void button39_Click(object sender, EventArgs e)
        {
            totalitzaciToolStripMenuItem_Click(new object(), new EventArgs());
        }

        private void button40_Click(object sender, EventArgs e)
        {
            imprimir imp = new imprimir(new Comanda());
            imp.ShowDialog();
        }

       


       
        


     

      
        
                
        

     
        

        
       
        

      
        

       
       

     
        
 
      

        

     
      
        




        
        

       
       
       


        

       





  

     

      

       

      
      

       

        

       
    }
}