using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Heelana;

namespace PFC
{
    public partial class imprimir : Form
    {
        PrintDialog printDialog = new PrintDialog();
        
        Comanda comanda;
        FileStream file;
        StreamReader fileToPrint;
        System.Drawing.Font printFont;
        StreamWriter tiquet;
        Settings settings=new Settings(System.Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\cfg.xml");

        public imprimir(Object o)
        {
            InitializeComponent();
            printDialog.Document = printDocument1;
            comanda = (Comanda)o;
            
        }

        

       //Configurar impressi
        private void button1_Click(object sender, EventArgs e)
        {
             printDialog.ShowDialog(); //Amb aix configurarem la impressora on s'imprimir el tiquet
             settings.WriteString("Impresio", "Impresora", printDialog.PrinterSettings.PrinterName);
             settings.Save();
             textBox1.Text = settings.ReadString("Impresio", "Impresora", "");
        }

        //Imprimir
        private void button2_Click(object sender, EventArgs e)
        {
            file = new FileStream(System.Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\tiquet.doc", FileMode.Create);
            tiquet = new StreamWriter(file);
            printFont = new System.Drawing.Font("Arial", 10);
            //Prepara fitxer a imprimir,els tiquets seran d 40caracters x linea
            IList linees = comanda.Lineas;
            String nomprod = "";


            int maxCaracters = 40;
            int cont = 0;
            tiquet.WriteLine("U. Producte                       Import");
            tiquet.WriteLine("----------------------------------------");
            foreach (LineaComanda l in linees)
            {
                nomprod = l.Producte.Nom + " " + l.NotaAdicional;

                if (nomprod.Length < maxCaracters - 7)
                {
                    cont = nomprod.Length;
                    while (cont < maxCaracters - 7)
                    {
                        nomprod = nomprod + " "; //Omplim de espais en blanc fins arribar al seu limit
                        cont++;
                    }
                }
                
                tiquet.WriteLine(l.Quantitat + " " + nomprod + l.Producte.Preu * l.Quantitat + " ");
            }
            tiquet.WriteLine();
            decimal preu = comanda.Preu;
            tiquet.WriteLine("Total                             " + preu + "");

            decimal preumodificat = comanda.PreuModificat;
            decimal descompte = 0;

            if ((preumodificat > 0) && (preumodificat<preu)) //Noms serveix per descomptar el modificar Total..
            {
               descompte = preu-preumodificat;
            tiquet.WriteLine("Descompte                        -" + descompte + "");
            tiquet.WriteLine();
            tiquet.WriteLine("Total Final                       " + preumodificat + "");
            }
            tiquet.Close();

            fileToPrint = new StreamReader(System.Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\tiquet.doc"); //C:\Documents and Settings\xavi\Datos de programa
            printDialog.PrinterSettings.PrinterName = textBox1.Text;
            printDocument1.PrinterSettings = printDialog.PrinterSettings;
            
            
            try
            {
                printPreviewDialog1.Document = printDocument1;
             // printPreviewDialog1.ShowDialog();
                
                printDocument1.Print();
                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Problema al imprimir:" + ex.ToString(), "Problema", MessageBoxButtons.OK, MessageBoxIcon.Error);
                file.Close();
                fileToPrint.Close();
               // File.Delete(System.Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\tiquet.doc");
            }
        }

        //Event k llana el printDocument.Print()
        private void printDocument1_PrintPage_1(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            float yPos = 0f;
            int count = 0;
            float leftMargin = e.MarginBounds.Left;
            float topMargin = e.MarginBounds.Top;
            string line = null;
            float linesPerPage = e.MarginBounds.Height / printFont.GetHeight(e.Graphics);
            while (count < linesPerPage)
            {
                line = fileToPrint.ReadLine();
                if (line == null)
                {
                    break;
                }
                yPos = topMargin + count * printFont.GetHeight(e.Graphics);
                e.Graphics.DrawString(line, printFont, Brushes.Black, leftMargin, yPos, new StringFormat());
                count++;
            }
            if (line != null)
            {
                e.HasMorePages = true;
            }
            fileToPrint.Close();
            //File.Delete(System.Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\tiquet.doc");
        }

        private void imprimir_Load(object sender, EventArgs e)
        {
            if (!File.Exists(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\cfg.xml")) //Primer cop k l'obrim
            {
                MessageBox.Show("Es la primera vegada que s'intenta imprimir,es procedir a configurar la impressora", "Avs", MessageBoxButtons.OK, MessageBoxIcon.Information);
                button1_Click(new Object(),new EventArgs());
            }
            textBox1.Text = settings.ReadString("Impresio", "Impresora", "");
        }
    }
}