using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PFC.Aplicacio_;


namespace PFC
{
    public partial class AfegirNota_PDA : Form
    {
        AplicacioPrincipal aplicacio;
        DataGridView dataGridComanda;
       
        Comanda comanda;
        Color colorLinea;
        String preferencia;

        bool esPostre = false;

        public AfegirNota_PDA(Object o,Object o2,Object com)
        {
            InitializeComponent();
            aplicacio = (AplicacioPrincipal)o;
            dataGridComanda = (DataGridView)o2;
            
            comanda = (Comanda)com;
            if (comanda == null) comanda = new Comanda();

            colorLinea = dataGridComanda.CurrentRow.DefaultCellStyle.BackColor;
            preferencia =(String)dataGridComanda.CurrentRow.Cells["column9"].Value;
            esPostre = aplicacio.obtenirProducte((String)dataGridComanda.CurrentRow.Cells["Column2"].Value) == null;
        }

        private void AfegirNota_PDA_Load(object sender, EventArgs e)
        {  
            IList i=null;
            //Carreguem els camps de unitats producte i nom producte
            textBox1.Text = (String)dataGridComanda.CurrentRow.Cells["Column2"].Value;
            textBox2.Text = Convert.ToString(dataGridComanda.CurrentRow.Cells["Column1"].Value);

            //Carreguem les notes disponibles dins de la familia a la qual pertany el producte
            //als 12 combolist
           
             i = aplicacio.obtenirProducte(textBox1.Text).Grup.NotesAdicionals;
            foreach (NotesAdicionals nota in i)
            {
                comboBox1.Items.Add(nota.Descripcio);
                comboBox2.Items.Add(nota.Descripcio);
                comboBox3.Items.Add(nota.Descripcio);
                comboBox4.Items.Add(nota.Descripcio);
                comboBox5.Items.Add(nota.Descripcio);
                comboBox6.Items.Add(nota.Descripcio);
                comboBox7.Items.Add(nota.Descripcio);
                

            }
            //Creem tantes columnes com unitats tinguem
            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            int index = 0;
            for (int cont = 0; cont < Convert.ToInt16(textBox2.Text); cont++)
            {
                DataGridViewCheckBoxColumn c = new DataGridViewCheckBoxColumn();
                c.Width = 20;
                
                c.Name = Convert.ToString(cont+1);
                index = cont + 1;
                c.HeaderText = Convert.ToString(index);
                dataGridView1.Columns.Add(c);
            }
            

        }


        //Aix es necessari per saber de quin combo he de extreure el text, no puc accedir de cap ms manera que aixi
        private ComboBox obtenirCombo(int i)
        {
            ComboBox combo=null;
            switch (i)
            {
                case 0: combo = comboBox1; break;
                case 1: combo = comboBox2; break;
                case 2: combo = comboBox3; break;
                case 3: combo = comboBox4; break;
                case 4: combo = comboBox5; break;
                case 5: combo = comboBox6; break;
                case 6: combo = comboBox7; break;
                

            }
            return combo;
        }

        //Serveix per determinar si s'ha escollit una nota en cada combo utilitzat
        private bool campsCorrectes()
        {
           
            bool res=true;
            for (int i = 0; i < dataGridView1.Rows.Count-1; i++)
                if (obtenirCombo(i).Text == "") res = false;
            return res;
        }

        //Bot de confirmaci d'afegir notas
        private void button1_Click(object sender, EventArgs e)
        {
                int unitats=Convert.ToInt16(textBox2.Text);
                String[] notes = new String[unitats]; //Pot haver-hi un mxim de notes segons unitats tinguem 
                bool OK = true;
                bool seguir = true;
                int quantesNotes = new Int16();

            //*************Primer creem cada nota per cada unitat del producte******************//

                if (!campsCorrectes()){ //Si estan els camps degudament omplerts seguim
                    OK=false;
                  MessageBox.Show("En algun camp no has seleccionat la nota a aplicar als productes marcats", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); OK = false; }
                
                
            quantesNotes = crearNotaPerProducte(notes);
            
            //**********Ara comparar cada nota entre cada unitat i els que tinguin la mateixa seran ajuntats ja que compartirn una nota amb mateixes caracteristiques.
                bool[] repetit = new bool[unitats]; //Servir per evitar tornar a iterar una nota que ja est repetida i sumada anteriorment 
                
                int notesIgual=0;
                
                if(quantesNotes==0) //Si no hi alguna nota no podem seguir
                    seguir=false;


                if (OK)
                { //Indica si podem seguir o no en funci de si anteriorment em tingut algun error
                    //Si no hem afegit cap nota no podrem seguir


                    if (seguir) //Com hi ha hagut algun cambi i podem seguir, ja podem eliminar la columna actual desde on hem entrat,perque ara es motrar la linea desglosada
                    {
                        if (!esPostre)
                        {
                            if (aplicacio.existeixLinea(comanda.Id, aplicacio.obtenirProducte(textBox1.Text).Id, (String)dataGridComanda.CurrentRow.Cells["Column7"].Value,(String)dataGridComanda.CurrentRow.Cells["Column9"].Value))
                            {
                                LineaComanda linea = aplicacio.obtenirLineaComanda(comanda.Id, aplicacio.obtenirProducte(textBox1.Text).Id, (String)dataGridComanda.CurrentRow.Cells["Column7"].Value,(String)dataGridComanda.CurrentRow.Cells["Column9"].Value);
                                aplicacio.eliminarLineaComanda(linea);
                            }
                        }
                        //L'eliminem del datagrid
                        dataGridComanda.Rows.RemoveAt(dataGridComanda.CurrentRow.Index);

                        for (int a = 0; a < unitats; a++) //Per cada nota
                        {
                            if (!repetit[a])
                            {
                                notesIgual = 1; //L'1 s perqu es t en compte ella mateixa..
                                for (int b = a + 1; b < unitats; b++)
                                {
                                    if (notes[a] == notes[b]) //Si detecta que son notes exactes,agruparem el producte
                                    {
                                        notesIgual++;
                                        repetit[b] = true; //Aixi ja no caldr iterar aquest de nou
                                    }
                                }

                                //Ja podre afegir agrupats per notes identiques al datadrig de comanda principal(eliminant la linea de comanda original i possant'la desglossada pero poder atendre-les millor)
                                agruparProductesNotesIdentiques(notes, notesIgual, a);

                            }

                        }

                    }
                 }
                    else MessageBox.Show("No hi ha hagut cap modificaci,tot seguir igual", "Informaci", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    Close();
                }
       


        //********Bot Cancellar*********
        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }


        //*************Crea una nota per cada unitat del producte i retorna el nombre de notes que hi ha******************//
        private int crearNotaPerProducte(String[] notes)
        {
            String notaFinal = "";
            ComboBox combo = null;
            int quantesNotes = 0;

            for (int i = 0; i < Convert.ToInt16(textBox2.Text); i++) //Per cada columna
            {
                notaFinal = ""; //Inicialitzem al cambiar de columna

                for (int j = 0; j < dataGridView1.Rows.Count - 1; j++) //Per cada fila
                {
                    combo = obtenirCombo(j); //Obtenir la descripci de la nota de la fila actual

                    if ((dataGridView1[i, j].Value != null) && (dataGridView1[i, j].Value.Equals(true))) //Vol dir que est marcat 
                    {
                        notaFinal = notaFinal + "," + combo.Text;
                        quantesNotes++;
                    }

                }
                notes[i] = notaFinal; //Es guarda al vector de notes la nota de la columna actual
            }
            return quantesNotes;
        }


        /*************Agrupa els  productes que tenen notes identiques i les possa al datagrid de comanda****************/
        private void agruparProductesNotesIdentiques(String[] notes,int notesIgual,int a)
        {
            decimal preuUnitari=0;
        int quant,res=0;
        bool existeix=false;
        String  notaF = "";
            
            if (notes[a] != "")
                 notaF = notes[a].Substring(1);

                                   for(int i=0;i<dataGridComanda.Rows.Count;i++){
                                         if ((dataGridComanda.Rows[i].Cells["Column2"].Value.Equals(textBox1.Text))&&((String)dataGridComanda.Rows[i].Cells["Column7"].Value==notaF))
                                            //Es complir la condici existeix si apart d'existir un nom a la dataGrid t el camp NotaAdicional(no visible identic
                                        {
                                            res = i;
                                            existeix = true;
                                        }
                                       
                                      }

                                      if (existeix) //Si es un item que ja esta al datagrid,simplement incrementem la quantitat
                                      {
                                         
                                          quant = Convert.ToInt16(dataGridComanda.Rows[res].Cells["Column1"].Value);
                                          quant=quant+notesIgual;
                                          dataGridComanda.Rows[res].Cells["Column1"].Value = quant;
                                          //Total = Total - (decimal)dataGridView1.Rows[res].Cells["Column3"].Value;
                                          dataGridComanda.Rows[res].Cells["Column3"].Value = aplicacio.obtenirProducte(textBox1.Text).Preu * quant;
                                         
                                      }
                                      else //Si no existeix la linea, la posem per primer cop
                                      {
                                          if (esPostre) Convert.ToDecimal(dataGridComanda.CurrentRow.Cells["Column3"].Value);
                                          //preuUnitari = Convert.ToDecimal(dataGridComanda.Rows[res].Cells["Column3"].Value) / Convert.ToInt16(dataGridComanda.Rows[res].Cells["Column1"].Value);
                                          else
                                              preuUnitari = aplicacio.obtenirProducte(textBox1.Text).Preu;

                                        if (notaF != "")
                                            dataGridComanda.Rows.Add(notesIgual, textBox1.Text, preuUnitari * notesIgual, 0, aplicacio.lineaInicial, aplicacio.estat1, notaF, preferencia, aplicacio.imatgeNotaAfegida);
                                        else dataGridComanda.Rows.Add(notesIgual, textBox1.Text, preuUnitari * notesIgual, 0, aplicacio.lineaInicial, aplicacio.estat1, notaF, preferencia);

                                       dataGridComanda.Rows[dataGridComanda.Rows.Count - 1].DefaultCellStyle.BackColor = colorLinea;
                                         
                                      }
        }

        private void dataGridView1_RowsAdded(object sender, DataGridViewRowsAddedEventArgs e)
        {
            dataGridView1.Rows[e.RowIndex].Height = 20;
        }

    }
}
 