using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using PFC.Aplicacio_;

namespace PFC
{
    public partial class Frontal_PDA : Form
    {
        AplicacioPrincipal aplicacio;
        Comanda comanda=new Comanda();
        Taula taula=null;
        Cambrer cambrer = null;
        AfegirNota_PDA formNota;
        MostraNotes_PDA mostraNota;
        Cobrar_PDA cobrar;
        imprimir_PDA imp;


        decimal Total = 0;
        decimal TotalModificat = 0;
        bool esDecimal = false; //Serveix per saber si el que es vol modificar es un preu o una quantitat

        int quantsPrimers, quantsSegons, quantsPostres, quantsNoPref;



        public Frontal_PDA(Object o)
        {
            InitializeComponent();
            //aplicacio = new AplicacioPrincipal();
            aplicacio = (AplicacioPrincipal)o;
           

           
        }
      
/*****************************Metodes que carreguen informaci als controls corresponents***********/
        private void carregaTaules()
        {

            listView3.Clear();
            IList i = aplicacio.obtenirTaules();
            foreach (Taula t in i)
            {
                if (aplicacio.existeixComanda(t))
                {
                    String estat = aplicacio.obtenirComandaActual(t).Estat;
                    if (estat == aplicacio.estat1)
                        listView3.Items.Add(t.Nom, 0);
                    else if (estat == aplicacio.estat2)
                        listView3.Items.Add(t.Nom, 1);
                    else if (estat == aplicacio.comandaEstat3)
                        listView3.Items.Add(t.Nom, 2);
                    else //Eliminada
                        listView3.Items.Add(t.Nom, 3);
                }

                else //Si la taula encara es lliure
                    listView3.Items.Add(t.Nom, 3);
            }

        }




//*****************Carrega els grups al listView amb les seves imatges
        private void carregaGrups()
        {
            Image i = null;
            String ruta="";
            int cont = 0; //Indica l'index de la imatge a carregar
            IList l = aplicacio.obtenirGrupsProductes();
            foreach (GrupProducte g in l)
            {
                ruta=aplicacio.rutaImatges + g.Nom + ".jpg";

                if (File.Exists(ruta)) //Si hi ha imatge d'aquest producte
                {
                    i = new Bitmap(ruta);

                }
                else
                {
                    i = new Bitmap(aplicacio.imatgeNoDisponible);
                   
                }
                imageList1.Images.Add(i);
                listView1.Items.Add(g.Nom.ToUpper(), cont);
                cont++;
            }


        }

//*****************Carrega al control que li toca les lineas de la comanda actual de la taula passada per parmetre
        private void carregaLineas(Taula t)
        {
            dataGridView1.Rows.Clear();//1r netejem el datagrid

            if (aplicacio.existeixComanda(t))//&&(aplicacio.obtenirComandaActual(t).Estat!=aplicacio.estatEliminada)) //Si ja ha estat creada anteriorment la recuperem
            {
                aplicacio.obtenirLineasComanda(); //Aixo simplement fa un refresh de totes les lineas modificades
                comanda = aplicacio.obtenirComandaActual(t);
                IList i = aplicacio.obtenirLineasComanda(comanda);

               

                foreach (LineaComanda l in i)
                {
                   if(l.NotaAdicional!="") //Si cont una nota carreguem la imatge que indica que hi ha nota associada
                       dataGridView1.Rows.Add(l.Quantitat, l.Producte.Nom.ToUpper(), l.Producte.Preu * l.Quantitat, l.QuantsFinalitzats, aplicacio.determinaImatgeEstat(l.Estat), l.Estat,l.NotaAdicional,l.Preferencia, aplicacio.imatgeNotaAfegida);
                   else
                       dataGridView1.Rows.Add(l.Quantitat, l.Producte.Nom.ToUpper(), l.Producte.Preu * l.Quantitat, l.QuantsFinalitzats, aplicacio.determinaImatgeEstat(l.Estat), l.Estat, l.NotaAdicional, l.Preferencia);

                   //Cambia color del datagrid en funci de si es primer plat, segon o postres..
                   if (l.Preferencia == "1-Primer") //Si es primer plat
                       dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorPrimerPlat;
                   else if (l.Preferencia == "2-Segon")
                       dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorSegonPlat;
                   else if (l.Preferencia == "3-Postres")
                       dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorPostres;

                }

                Total = comanda.Preu;
                if (comanda.Estat == aplicacio.estatEliminada)
                    comanda.PreuModificat = 0;

                if (comanda.PreuModificat != 0)
                {
                    TotalModificat = comanda.PreuModificat;
                    checkBox1.Visible = true;
                    textTotalModificat.Text =Convert.ToString(TotalModificat);
                    label5.Visible = true;
                    label4.Visible = true;
                    textTotalModificat.Visible = true;
                }
            }
            else
            { //Altramen en creem una nova
                comanda = new Comanda();
                comanda.Estat = aplicacio.estat1;
                Total = 0;
            }

            textTotal.Text = Convert.ToString(Total);
           
        }

//*****************Es carreguen els controls inicials al carregar el formulari per primer cop
        private void Frontal_PDA_Load(object sender, EventArgs e)
        {
            //Carreguem les families de producte al primer listView
            panellProductes.Visible = false;
           // panellDetall.Visible = false;
         
            carregaGrups();
            //I les taules
            carregaTaules();
            timer1.Interval = 2000;
            timer1.Start();

            

            button6.Enabled = false;
            button20.Enabled = false;
            
            ;

            LogginCambrer_PDA loggin = new LogginCambrer_PDA(aplicacio);
            loggin.ShowDialog();
           cambrer = loggin.cambrer; //Recollim el cambrer ja loguejat

          //  cambrer = aplicacio.obtenirCambrer(1);
           dataGridView1.Font= new System.Drawing.Font("Comic Sans MS", 5.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
        }
       
        
/***************************PANELL PRINCIPAL DE COMANDES*************************************************/
         
        
//*****************/En clickar sobre de una familia, es mostren els productes d'aquesta al costat
       
        private void listView1_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {
            listView2.Clear(); //Primer de tot netejem la finestra..
            imageList2.Images.Clear();

            GrupProducte g = aplicacio.obtenirGrupProducte(e.Item.Text);
            Image imatge = null;
            String ruta = "";
            int cont = 0; //Indica l'index de la imatge a carregar
            //IList i = g.Productes; Aixi funciona perfectament,pero ho vull ordenat per nom,per aix he creat una consulta
            IList i = aplicacio.obtenirProductes(g);
            
            if (g.Nom == "Postres")
            {
                imageList2.Images.Add(aplicacio.imatgeCreaPostres);
                listView2.Items.Add("CREADOR DE POSTRES", 0);
                cont = 1;

            }
            foreach (Producte p in i)
            {
                ruta = aplicacio.rutaImatges + p.Nom + ".jpg";
                if (p.Disponible) //Noms els disponibles es mostraran
                {
                    if (File.Exists(ruta)) //Si hi ha imatge d'aquest producte
                    {
                        imatge = new Bitmap(ruta);


                    }
                    else
                    {
                        imatge = new Bitmap(aplicacio.imatgeNoDisponible);
                    }
                    imageList2.Images.Add(imatge);
                    listView2.Items.Add(p.Nom.ToUpper(), cont);
                    cont++;
                }
            }
        }

        
        string entrada; //Producte escollit,el declaro global perque el necessitu en un altre winform
        int res;
//*****************Afegir linea:Aqui es mostren els productes de la familia escollida al listView1 i s'escull el producte que afegirem al datagrid
        private void listView2_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {

            int quant = 0;

            decimal importPostre = 0;
            bool existeix = false;
            entrada = e.Item.Text;

            //Si volem crear un postre a mida..
            if (entrada == "CREADOR DE POSTRES")
            {
                GrupProducte g = aplicacio.obtenirGrupProducte("Postres");
                postres_PDA postre = new postres_PDA(aplicacio);
                postre.ShowDialog();
                if (postre.import > 0)
                {
                    importPostre = postre.import;
                    entrada = postre.nomPostre;
                }
                else entrada = null;
            }

            if (entrada != null)
            {



                //Si ja est a la comanda aquest producte, augmenta la quantitat del producte
                for (int i = 0; i < dataGridView1.Rows.Count; i++)
                {
                    if (((String)dataGridView1.Rows[i].Cells["Column2"].Value == entrada) && ((String)dataGridView1.Rows[i].Cells["Column7"].Value == "") && (comboBoxPreferencia.Text == (String)dataGridView1.Rows[i].Cells["Column9"].Value))
                    //Es complir la condici existeix si apart d'existir un nom a la dataGrid t el camp NotaAdicional(no visible) en buit i si t la mateixa preferencia
                    {
                        res = i;
                        existeix = true;
                    }

                }
                if (existeix) //Si es un item que ja esta al datagrid,simplement incrementem la quantitat
                {

                    quant = Convert.ToInt16(dataGridView1.Rows[res].Cells["Column1"].Value);
                    quant++;
                    dataGridView1.Rows[res].Cells["Column1"].Value = quant;
                    Total = Total - (decimal)dataGridView1.Rows[res].Cells["Column3"].Value;

                    dataGridView1.Rows[res].Cells["Column3"].Value = aplicacio.obtenirProducte(entrada).Preu * quant;

                }
                else
                {
                    panellCalc.Visible = true;
                    panellProductes.Visible = false;
                    panellPref.Visible = true;
                    modeCalc.Text = "afegirProducte";
                    titolCalc.Text = "Introdueix les unitats demanades i preferncia:";
                }


            }
        }
        
        

 //****************But de enviar comanda
        private void button5_Click(object sender, EventArgs e)
        {
                        
            
            if (dataGridView1.Rows.Count > 0)
            {

                if (comanda.Id == 0)//Si es nova
                {
                    comanda = new Comanda();
                    comanda.Estat = aplicacio.estat1;
                    comanda.Taula = taula;

                }
                else  //Si ja hi era i era una comanda que ha estat eliminada,l'aprofitarem i la possarem de nou a inicial
                {
                    if(comanda.Estat.Equals(aplicacio.estatEliminada))
                        comanda.Estat=aplicacio.estat1;
                }
                if (checkBox1.Checked)
                    comanda.PreuModificat = TotalModificat;
                else comanda.PreuModificat = 0; //Si abans elteniem marcat i ara no..el posem a 0 de nou
                comanda.Preu = Total;
                LineaComanda l = null;


                //Finalment guardem la comanda amb totes les seves linees a la BD
                aplicacio.guardarComanda(comanda);

                //Recorrem totes les files per anar creant linees de comanda
                for (int i = 0; i < dataGridView1.Rows.Count; i++)
                {
                    string producte = (String)dataGridView1.Rows[i].Cells["Column2"].Value;
                    int quantitat = Convert.ToInt32(dataGridView1.Rows[i].Cells["Column1"].Value);
                    string estat = (String)dataGridView1.Rows[i].Cells["Column8"].Value;
                    string nota = (String)dataGridView1.Rows[i].Cells["Column7"].Value;
                    string preferencia = (String)dataGridView1.Rows[i].Cells["Column9"].Value;
                    if (nota == null) nota = "";

                    //Mirem si ja existeix la linea,si es aixi la modifiquem
                    if (aplicacio.existeixLinea(comanda.Id, aplicacio.obtenirProducte(producte).Id,nota,preferencia))
                        l = aplicacio.obtenirLineaComanda(comanda.Id, aplicacio.obtenirProducte(producte).Id, nota,preferencia);

                    else     //Si no existeix, es que s nova             
                        l = new LineaComanda();


                    l.Producte = aplicacio.obtenirProducte(producte);
                    l.Cambrer = aplicacio.obtenirCambrer(cambrer.Id);
                    l.Comanda = comanda;
                    l.Quantitat = quantitat;
                    if(l.Id==0)//Noms si es nova possarem l'estat, que ser inicial, altrament no modificarem
                    l.Estat = estat;
                    l.NotaAdicional = nota;
                    l.Preferencia = preferencia;
                    comanda.Lineas.Add(l);
                    aplicacio.guardarLineaComanda(l);
                }
                MessageBox.Show("COMANDA ENVIADA CORRECTAMENT", "Confirmaci", MessageBoxButtons.OK, MessageBoxIcon.Information);
                panellDetall.Visible = false;
                labelTaula.Visible = true;
                listView3.Visible = true;
            }
            else MessageBox.Show("No es pot enviar a la cuina una comanda buida", "Comanda buida", MessageBoxButtons.OK, MessageBoxIcon.Error);
           
        }


 //Quan es marca el chekbox de total modificat,es guarda la comanda amb el nou valor
        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (aplicacio.existeixComanda(taula))
            {
                if (checkBox1.Checked)
                    comanda.PreuModificat = TotalModificat;
                else comanda.PreuModificat = 0; //Si abans elteniem marcat i ara no..el posem a 0 de nou
                comanda.Preu = Total;

                //Guardem la comanda a la BD
                aplicacio.guardarComanda(comanda);
            }



        }



//*****************/Boto d'eliminar linea comanda
        private void button6_Click(object sender, EventArgs e)
        {
            int idProd=-1;
            LineaComanda linea;
            string producte = (String)dataGridView1.CurrentRow.Cells["Column2"].Value;
            string nota = (String)dataGridView1.CurrentRow.Cells["Column7"].Value;
            string preferencia = (String)dataGridView1.CurrentRow.Cells["Column9"].Value;
            int unitats=Convert.ToInt16(dataGridView1[0,dataGridView1.CurrentRow.Index].Value);

            if (nota == null) nota = "";
            //Abans d'esborrar controlem el Total
            Total = Total - (decimal)dataGridView1.CurrentRow.Cells["Column3"].Value;
            textTotal.Text =Convert.ToString(Total);

            //Actualitzo els primers plats,segons,etc.
            actualitzaInfoPlats(preferencia, unitats,"resta");
           


               idProd = aplicacio.obtenirProducte(producte).Id;

            dataGridView1.Rows.RemoveAt(dataGridView1.CurrentRow.Index);

           
                
            if (aplicacio.existeixLinea(comanda.Id, idProd,nota,preferencia))
            {
                linea = aplicacio.obtenirLineaComanda(comanda.Id, idProd,nota,preferencia);
                aplicacio.eliminarLineaComanda(linea);
            }
                
            
            //Si era l'ultima linea, no podrem borrar...anulem el boto de borrar dons i posem la comanda com a eliminada
            if (dataGridView1.Rows.Count == 0)
            {
             
               // ultimaLineaEliminada = true;
                //button2_Click(new Object(), new EventArgs());//Cridem l'accio de anullar comanda
                if (comanda.Id != 0)
                {
                      comanda.Estat = "Eliminada";
                            comanda.Preu = 0;
                            aplicacio.guardarComanda(comanda); //La modificar

                        
                        
                        Total = 0;
                        TotalModificat = 0;
                        textTotal.Text = "0";
                        dataGridView1.Rows.Clear();
                        button6.Enabled = false;
                        button20.Enabled = false;
                        
                        ;
                        label4.Visible = false;
                        label5.Visible = false;
                        textTotalModificat.Visible = false;
                        checkBox1.Visible = false;
                }
            }
          
       

        }


        //**************Bot per afegir una nota a la linea**********
        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            //Quan li donem a qualsevol casella s'actualitza la fila i a ms si li hem donat a afegir nota,ens permet fer-ho
            
            String unitats =Convert.ToString(dataGridView1.Rows[e.RowIndex].Cells["Column1"].Value);
            String producte = (String)dataGridView1.Rows[e.RowIndex].Cells["Column2"].Value;
            String nota = (String)dataGridView1.Rows[e.RowIndex].Cells["Column7"].Value;
            String estat = "";
            String preferencia = (String)dataGridView1.CurrentRow.Cells["Column9"].Value;

            int idProd = -1;
            //Pot ser que l'estat hagi cambiat pero no 'hagin refrescat les linees,per aixo obtenim l'estat directament de la BD si existeix
             idProd = aplicacio.obtenirProducte(producte).Id;

            if (aplicacio.existeixLinea(comanda.Id, idProd, nota,preferencia))
            {
               LineaComanda linea = aplicacio.obtenirLineaComanda(comanda.Id, aplicacio.obtenirProducte(producte).Id, nota,preferencia);
               estat = linea.Estat;
                dataGridView1.Rows[e.RowIndex].Cells["Column8"].Value = estat;
                dataGridView1.Rows[e.RowIndex].Cells["Column4"].Value = aplicacio.determinaImatgeEstat(estat);
                dataGridView1.Rows[e.RowIndex].Cells["Column5"].Value = linea.QuantsFinalitzats;
            }
            else estat = (String)dataGridView1.Rows[e.RowIndex].Cells["Column8"].Value;
            //I de passada ja que obtenim linea de la bd,refresquem aquest estat si ha cambiat.




            if (e.ColumnIndex == 8) 
            {
                if (nota == "") //Si encara no t nota assignada,obrim el formulari
                {
                    if (((comanda.Id != 0) && (estat == aplicacio.estat1)) || (comandaEncaraNoEnviada()))
                    {
                        formNota = new AfegirNota_PDA(aplicacio, dataGridView1, comanda);
                        formNota.ShowDialog();
                    }

                }
                else //Si la nota ha estat creada
                {

                    mostraNota = new MostraNotes_PDA(unitats, producte, nota, estat == aplicacio.estat1);
                    mostraNota.ShowDialog();
                    if (mostraNota.modificar)
                    {
                        formNota = new AfegirNota_PDA(aplicacio, dataGridView1, comanda);
                        formNota.ShowDialog();
                    }


                }
            }
            //*****************Editar unitats: Permet cambiar les unitats de una linea,aplicant els cambis corresponents als preus
            else if (e.ColumnIndex == 0) 
            {
                UnitatsAbans.Text = unitats;
                panellDetall.Visible = false;
                panellCalc.Visible = true;
                panellPref.Visible = false;
                modeCalc.Text = "editarUnitats";
                titolCalc.Text = "Introdueix les unitats:";
            }
            
        }


        //Simplement l'hi dona una altura a les files
        private void dataGridView1_RowsAdded(object sender, DataGridViewRowsAddedEventArgs e)
        {
            dataGridView1.Rows[e.RowIndex].Height = 20;
          int unitats= Convert.ToInt16(dataGridView1[0,e.RowIndex].Value); //Unitats
          String pref= (String)dataGridView1[7,e.RowIndex].Value; //Preferncia

          actualitzaInfoPlats(pref, unitats,"suma");
                   
        }









/****************************PANELL DE TAULES*******************************************************/
        //Escollir una taula
       
        //en clickar sobre una taula carreguem les seves dades al panell de comanda
       

        private void listView3_ItemSelectionChanged(object sender, ListViewItemSelectionChangedEventArgs e)
        {

            listView3.Visible = false;
            labelTaula.Visible = false;
            ButoEnrrere.Enabled = true;
            quantsNoPref = quantsPostres = quantsPrimers = quantsSegons = 0; //Reinicialitzem a 0
            labelPrimers.Text = Convert.ToString(quantsPrimers);
            labelSegons.Text = Convert.ToString(quantsSegons);
            labelPostres.Text = Convert.ToString(quantsPostres);
            labelNoPref.Text = Convert.ToString(quantsNoPref);

            try
            {
                String eleccio = e.Item.Text;
                taula = aplicacio.obtenirTaula(eleccio);
                carregaLineas(taula); if (dataGridView1.Rows.Count > 0)
                {
                    button6.Enabled = true; //Si hi ha alguna linea,habilitar el boto d'eliminar
                    button20.Enabled = true; //  I els de modificaci de linea

                    textCalculadora.Enabled = true;
                }
                else
                {
                    button6.Enabled = false;
                    button20.Enabled = false;

                    
                }

                label2.Text = "Taula Actual: " + taula.Nom;
            }
            catch (Exception) { }
            panellProductes.Visible = true;
        }

        private bool comandaEncaraNoEnviada()
        {
            return ((comanda.Id == 0) || (comanda.Estat == aplicacio.estatEliminada));
        }




/*****************************TECLAT NUMRIC*****************************************/
        private void button7_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "1";
        }

        private void button8_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "2";
        }

        private void button9_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "3";
        }

        private void button10_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "4";
        }

        private void button11_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "5";
        }

        private void button12_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "6";
        }

        private void button13_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "7";
        }

        private void button14_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "8";
        }

        private void button15_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "9";
        }

        private void button17_Click(object sender, EventArgs e)
        {
            textCalculadora.Clear();
            esDecimal = false;
        }

        private void button16_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "0";
        }

        private void button18_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + "00";
        }

        private void button19_Click(object sender, EventArgs e)
        {
            textCalculadora.Text = textCalculadora.Text + ",";
            esDecimal = true;
        }

        //*****************Editar Preu: Permet cambiar el preu al total final
        private void button20_Click(object sender, EventArgs e)
        {
            panellDetall.Visible = false;
            panellCalc.Visible = true;
            panellPref.Visible = false;
            modeCalc.Text = "editarTotal";
            titolCalc.Text = "Introdueix import:";
        }

        
       



//****************** ACTUALITZACI DE DADES*************************************************//

        //Cada 1 segon(o els k vulgui), s'actulitzen les dades per si hi han hagut cambis d'estat en les linees de comanda
        private void timer1_Tick(object sender, EventArgs e)
        {
           // if (!panellProductes.Visible) //Noms quan est actiu el panell que mostra les taules s'actulitza cada 2segons l'estat de la comanda actual
                carregaTaules();
           
        }

        //Bot per refrescar les linees de la comanda
        private void button22_Click(object sender, EventArgs e)
        {
            RefrescarLineas();
            
        }

        private void RefrescarLineas()
        {
            if (aplicacio.existeixComanda(taula))
                carregaLineas(taula);
        }

      


//******************************IMPLEMENTACI DELS BOTONS DEL MARGE ESQUERRE*****************************************



        //*****************bot veure taules
        private void button1_Click(object sender, EventArgs e)
        {
            panellDetall.Visible = false;
            panellProductes.Visible = false;
            carregaTaules();
            textTotalModificat.Visible = false;
            checkBox1.Visible = false;
            label4.Visible = false;
            label5.Visible = false;
            listView3.Visible = true;
            labelTaula.Visible = true;
        }


        //*****************Bot Anullar comanda
        private void button2_Click(object sender, EventArgs e)
        {


           
            if ((panellDetall.Visible) && (dataGridView1.Rows.Count > 0))
            {
                LineaComanda linea;
                string producte;
                string nota ;
                string preferencia ;
                int files = dataGridView1.Rows.Count;
                DialogResult d = MessageBox.Show("Estas segur que vols eliminar tota la comanda ?", "Confirmaci", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

                if (d.ToString().Equals("OK"))
                {
                    if (comanda.Id != 0) //Noms posara una comanda a estat Eliminada si ha estat guardada anteriorment
                    {
                        for (int i = 0; i < files; i++)
                        {
                            producte = (String)dataGridView1.CurrentRow.Cells["Column2"].Value;
                            nota = (String)dataGridView1.CurrentRow.Cells["Column7"].Value;
                            preferencia = (String)dataGridView1.CurrentRow.Cells["Column9"].Value;
                            if (nota == null) nota = "";
                           
                            dataGridView1.Rows.RemoveAt(dataGridView1.CurrentRow.Index);

                            
                                if (aplicacio.existeixLinea(comanda.Id, aplicacio.obtenirProducte(producte).Id, nota,preferencia))
                                {
                                    linea = aplicacio.obtenirLineaComanda(comanda.Id, aplicacio.obtenirProducte(producte).Id, nota,preferencia);
                                    aplicacio.eliminarLineaComanda(linea);
                                }
                            
                        }

                        comanda.Estat = "Eliminada";
                        comanda.Preu = 0;
                        aplicacio.guardarComanda(comanda); //La modificar


                    }
                    Total = 0;
                    TotalModificat = 0;
                    textTotal.Text = "0";
                    dataGridView1.Rows.Clear();
                    button6.Enabled = false;
                    button20.Enabled = false;
                    
                   
                    label4.Visible = false;
                    label5.Visible = false;
                    textTotalModificat.Visible = false;
                    checkBox1.Visible = false;

                    labelPrimers.Text = "0";
                    labelSegons.Text = "0";
                    labelPostres.Text = "0";
                    labelNoPref.Text = "0";
                    
                }
            }

        }


        //************Bot sortir
        private void button4_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }



        //***********Bot de cobrar la comanda
        private void button3_Click(object sender, EventArgs e)
        {
            //El bot noms reaccionar si hi ha linees de comanda, si existeix la comanda , i si est en estatpendent de cobrar
            //Primer de tot refresquem les linees
            RefrescarLineas();
            Pagament pagament = null;
           
           decimal preufinal=0;

          // IList i = aplicacio.obtenirTipusPagaments(); //Obtenim els tipus d pagaments disponibles
            //   foreach(TipusPagament t in i)


                     if ((panellDetall.Visible) && (dataGridView1.Rows.Count > 0) && (!comandaEncaraNoEnviada()) && (comanda.Estat==aplicacio.comandaEstat3))
                     {

                         if (checkBox1.Checked)
                         {
                             preufinal=Convert.ToDecimal(textTotalModificat.Text);
                             cobrar = new Cobrar_PDA(preufinal,aplicacio);
                         }               
                         else
                         {
                              preufinal=Convert.ToDecimal(textTotal.Text);
                              cobrar = new Cobrar_PDA(preufinal, aplicacio);
                         }

                         cobrar.ShowDialog();

                         //Un cop hem realitzat l'operaci
                         if (cobrar.cobrat != null)
                         {
                             if (cobrar.cobrat == "KO") //No ha estat cobrat
                                 comanda.Estat = "No cobrada";
                             else
                             {
                                 comanda.Estat = "Cobrada";
                                 pagament = new Pagament();
                                 pagament.Import = preufinal;
                                 pagament.TipusPagament = cobrar.tipus;
                                 pagament.Comanda = comanda;
                                 aplicacio.guardarPagament(pagament);
                        
                       
                       
                        
                             }
                             
                             aplicacio.guardarComanda(comanda);
                              comanda.Pagaments.Add(pagament);                                    
                            
                     
                             button1_Click(new object(), new EventArgs()); //Cliquem al but de veure taules
                         }
                
                     } 
        }



 //Bot  impressi
        
        private void button24_Click(object sender, EventArgs e)
        {
            RefrescarLineas();
            if ((panellDetall.Visible) && (dataGridView1.Rows.Count > 0) && (!comandaEncaraNoEnviada()) && (comanda.Estat == aplicacio.comandaEstat3))
            {
                imp = new imprimir_PDA(comanda);
                imp.ShowDialog();
            }
        }
       

//Al donar-li al bot aplicar canvi preferencia, cambia la lineaa Actual seleccionada de preferencia
        private void button23_Click(object sender, EventArgs e)
        {
            LineaComanda linea = null;
            if (dataGridView1.Rows.Count > 0)
            {
                String producte = (String)dataGridView1.CurrentRow.Cells["Column2"].Value;
                String nota = (String)dataGridView1.CurrentRow.Cells["Column7"].Value;
                String preferencia = (String)dataGridView1.CurrentRow.Cells["Column9"].Value;
                if (aplicacio.existeixLinea(comanda.Id, aplicacio.obtenirProducte(producte).Id,nota,preferencia ))
                {
                    linea = aplicacio.obtenirLineaComanda(comanda.Id, aplicacio.obtenirProducte(producte).Id, nota,preferencia);
                    linea.Preferencia = comboBoxPreferencia.Text;
                    aplicacio.guardarLineaComanda(linea);
                }
                
                dataGridView1.CurrentRow.Cells["Column9"].Value = comboBoxPreferencia.Text;

                if (comboBoxPreferencia.Text == "1-Primer")
                    dataGridView1.CurrentRow.DefaultCellStyle.BackColor = aplicacio.colorPrimerPlat;

                else if (comboBoxPreferencia.Text == "2-Segon")
                    dataGridView1.CurrentRow.DefaultCellStyle.BackColor = aplicacio.colorSegonPlat;

                else if (comboBoxPreferencia.Text == "3-Postres")
                    dataGridView1.CurrentRow.DefaultCellStyle.BackColor = aplicacio.colorPostres;

                else if (comboBoxPreferencia.Text == "0-No Pref.")
                    dataGridView1.CurrentRow.DefaultCellStyle.BackColor = Color.White;
            }
        }

        

        private void ButoEnrrere_Click(object sender, EventArgs e)
        {
            if (panellProductes.Visible)
            {
               
                listView3.Visible = true;
                labelTaula.Visible = true;
                ButoEnrrere.Enabled = false;
                
                panellProductes.Visible = false;
                panellProductes.SendToBack();
            }
            else if (panellDetall.Visible)
            {
                panellDetall.Visible=false;
                panellDetall.SendToBack();
                panellProductes.Visible = true;
                
            }
            else if (panellCalc.Visible)
            {
                panellCalc.Visible = false;
                if (modeCalc.Text == "afegirProducte")
                    panellProductes.Visible = true;
                else //editarTotal i editarUnitats 
                    panellDetall.Visible = true;
                
                textCalculadora.Clear();
            }
        }

       

        //But ok(calculadora)
        private void button1_Click_1(object sender, EventArgs e)
        {
            int quant;
            bool continuar = true;
            if (textCalculadora.Text != "")
            {
                if (modeCalc.Text == "afegirProducte")
                {

                    if ((radioButton1rPlat.Checked) || (radioButton2nPlat.Checked) || (radioButtonPostres.Checked) || (radioButtonNoPref.Checked))
                    {
                        continuar = true;
                        quant = Convert.ToInt16(textCalculadora.Text);
                        String pref = "";

                        

                        //Afegim la linea i pintem els fons de un color diferent per distingir entre preferencies dels plats

                        if (radioButton1rPlat.Checked)
                        {
                            pref = "1-Primer";
                            dataGridView1.Rows.Add(quant, entrada, aplicacio.obtenirProducte(entrada).Preu, 0, aplicacio.lineaInicial, aplicacio.estat1, "", pref);
                            dataGridView1.Rows[dataGridView1.Rows.Count-1].DefaultCellStyle.BackColor = aplicacio.colorPrimerPlat;
                           
                          
                        }
                        else if (radioButton2nPlat.Checked)
                        {
                            pref = "2-Segon";
                            dataGridView1.Rows.Add(quant, entrada, aplicacio.obtenirProducte(entrada).Preu, 0, aplicacio.lineaInicial, aplicacio.estat1, "", pref);
                            dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorSegonPlat;
                            
                           
                        }
                        else if (radioButtonPostres.Checked)
                        {
                            pref = "3-Postres";
                            dataGridView1.Rows.Add(quant, entrada, aplicacio.obtenirProducte(entrada).Preu, 0, aplicacio.lineaInicial, aplicacio.estat1, "", pref);
                            dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorPostres;
                           
                           
                        }
                        else if (radioButtonNoPref.Checked) {
                           
                            pref = "0-No Pref.";
                            dataGridView1.Rows.Add(quant, entrada, aplicacio.obtenirProducte(entrada).Preu, 0, aplicacio.lineaInicial, aplicacio.estat1, "", pref);
                            
                        }
                       
                        res = dataGridView1.Rows.Count - 1;
                        Total = Total + (decimal)dataGridView1.Rows[res].Cells["Column3"].Value;

                        textTotal.Text = Convert.ToString(Total);
                        button6.Enabled = true;
                        button20.Enabled = true;

                        panellProductes.Visible = true;
                    }
                    else
                    {
                        MessageBox.Show("Escull una preferncia", "Preferncia", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        continuar = false;
                    }
                  
                }

                else if (modeCalc.Text == "editarTotal")
                {

                    textTotalModificat.Text = textCalculadora.Text;
                    TotalModificat = Convert.ToDecimal(textCalculadora.Text);
                    label4.Visible = true;
                    label5.Visible = true;
                    textTotalModificat.Visible = true;
                    checkBox1.Visible = true;
                    checkBox1.Checked = true;

                    esDecimal = false;
                    panellDetall.Visible = true;

                }
                else //mode="editarUnitats"
                {
                    String producte = (String)dataGridView1.CurrentRow.Cells["Column2"].Value;
                    int quantitat = Convert.ToInt32(dataGridView1.CurrentRow.Cells["Column1"].Value);
                    decimal import = Convert.ToDecimal(dataGridView1.CurrentRow.Cells["Column3"].Value);
                    String pref=(String)dataGridView1.CurrentRow.Cells["Column9"].Value;

                    if (!esDecimal)
                    {
                        dataGridView1.CurrentRow.Cells["Column1"].Value = textCalculadora.Text;
                        Total = Total - import;

                            import = aplicacio.obtenirProducte(producte).Preu * Convert.ToInt16(textCalculadora.Text);
                        
                        dataGridView1.CurrentRow.Cells["Column3"].Value = import;
                        Total = Total + Convert.ToDecimal(dataGridView1.CurrentRow.Cells["Column3"].Value);
                        textTotal.Text = Convert.ToString(Total);

                        if (pref == "1-Primer")
                        {
                            quantsPrimers = quantsPrimers - Convert.ToInt16(UnitatsAbans.Text); //Restem les antigues unitats 
                            quantsPrimers = quantsPrimers + Convert.ToInt16(textCalculadora.Text); //I actualitzem
                            labelPrimers.Text = Convert.ToString(quantsPrimers);
                        }
                        else if (pref == "2-Segon")
                        {
                            quantsSegons = quantsSegons - Convert.ToInt16(UnitatsAbans.Text); //Restem les antigues unitats 
                            quantsSegons = quantsSegons + Convert.ToInt16(textCalculadora.Text); //I actualitzem
                            labelSegons.Text = Convert.ToString(quantsSegons);
                           
                        }
                       else if ( pref == "3-Postres")
                        {
                            quantsPostres = quantsPostres - Convert.ToInt16(UnitatsAbans.Text); //Restem les antigues unitats 
                            quantsPostres = quantsPostres + Convert.ToInt16(textCalculadora.Text); //I actualitzem
                            labelPostres.Text = Convert.ToString(quantsPostres);
                         
                        }
                        else
                        {
                            quantsNoPref = quantsNoPref - Convert.ToInt16(UnitatsAbans.Text); //Restem les antigues unitats 
                            quantsNoPref = quantsNoPref + Convert.ToInt16(textCalculadora.Text); //I actualitzem
                            labelNoPref.Text = Convert.ToString(quantsNoPref);
                        }
                    }
                    else MessageBox.Show("Introdueix un valor vlid per indicar les unitats", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);

                    textCalculadora.Clear();
                    esDecimal = false;
                    panellDetall.Visible = true;


                }
                if (continuar)
                {
                    panellCalc.Visible = false;
                    textCalculadora.Clear();
                    panellPref.Visible = true;
                    titolCalc.Text = "";
                }
            }
        }

        //Detall comanda
        private void button25_Click(object sender, EventArgs e)
        {
            panellProductes.Visible = false;
            panellDetall.Visible = true;
        }

       

        //Actualitza la informaci resumida a la pantalla de productes,on posa numeros de 1rs plats,2ons,postres i begudes.

        public void actualitzaInfoPlats(String preferencia, int unitats,String operacio)
        {
            if (operacio == "resta")
            {
                if (preferencia == "1-Primer")
                    quantsPrimers = quantsPrimers - unitats;
                else if (preferencia == "2-Segon")
                    quantsSegons = quantsSegons - unitats;
                else if (preferencia == "3-Postres")
                    quantsPostres = quantsPostres - unitats;
                else quantsNoPref = quantsNoPref - unitats;
            }
            else
            {
                if (preferencia == "1-Primer")
                    quantsPrimers = quantsPrimers + unitats;
                else if (preferencia == "2-Segon")
                    quantsSegons = quantsSegons + unitats;
                else if (preferencia == "3-Postres")
                    quantsPostres = quantsPostres + unitats;
                else quantsNoPref = quantsNoPref + unitats;
            }

            labelPrimers.Text = Convert.ToString(quantsPrimers);
            labelSegons.Text = Convert.ToString(quantsSegons);
            labelPostres.Text = Convert.ToString(quantsPostres);
            labelNoPref.Text = Convert.ToString(quantsNoPref);

        }

     
      

       

        

       

    

       

        

        

        

      


       
   
    







    }
}