﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PFC.Aplicacio_;

namespace PFC
{
    public partial class Terminal : Form
    {
        Taula taula=null;
        Comanda comanda=null;  //Comanda actual
        AplicacioPrincipal aplicacio;
        int opcio = 1; //Aquesta opcio ens diu de quin tipus de terminal parlem, pot ser terminal per cuina,barra,bodega o combinacions.
        bool guardar = true;

        public Terminal(Object o,int i)
        {
            InitializeComponent();
            aplicacio = (AplicacioPrincipal)o;
            opcio = i;
            switch (opcio)
            {
                case 1:
                    this.Text = "Terminal de cuina";
                    break;
                case 2:
                    this.Text = "Terminal de barra";
                    break;
                case 3:
                    this.Text = "Terminal de bodega";
                    break;
                case 4:
                    this.Text = "Terminal de bodega i barra";
                    break;
                case 5:
                    this.Text = "Terminal de bodega, barra i cuina";
                    break;
            }

        }

        private void Frontal_Cuina_Load(object sender, EventArgs e)
        {
            
            timer1.Interval = 2000;
            timer1.Start();
            carregaTaules();

        }


/*****************************Metodes que carreguen informació als controls corresponents***********/

        private void carregaLineas(Taula t) //Nomes refrescarà les linees si hi ha hagut cambis a la base de dades
        {
            try
            {
                comanda = aplicacio.obtenirComandaActual(t);
                IList i = null;


                switch (opcio)
                {
                    case 1: //Opcio de terminal de cuina exclusivament
                        i = aplicacio.obtenirLineasCuina(comanda);
                        break;
                    case 2: //Opcio de terminal de barra exclusivament
                        i = aplicacio.obtenirLineasBarra(comanda);
                        break;
                    case 3: //Opcio de terminal de bodega exclusivament
                        i = aplicacio.obtenirLineasBodega(comanda);
                        break;
                    case 4: //Opcio de terminal de bodega+barra 
                        i = aplicacio.obtenirLineasBodega(comanda);
                        IList a = aplicacio.obtenirLineasBarra(comanda);
                        foreach (object o in a)
                            i.Add(o);
                        break;

                    case 5: //Opcio de terminal de tots els tipus de linea
                        //i = comanda.Lineas;
                        i = aplicacio.obtenirLineasComanda(comanda);
                        break;

                    case 6: //Opcio de terminal de postres
                        i = aplicacio.obtenirLineasPostres(comanda);
                        break;
                }


                if ((i.Count != dataGridView1.Rows.Count)||(hiHaCambis())) //Si ha cambiat el nombre de linees es que s'ha agefit o borrat alguna linea
                 {
                     int indexAntic = 0;
                    if(dataGridView1.CurrentRow!=null)
                    indexAntic = dataGridView1.CurrentRow.Index;
                    dataGridView1.Rows.Clear();//1r netejem el datagrid
                  
                    foreach (LineaComanda l in i)
                    {

                        if ((l.QuantsFinalitzats < l.Quantitat) && (l.QuantsFinalitzats != 0) && (l.Estat.Equals("Finalitzat")))//Si ja tenia la linea finalitzada i s'ha afegit un altre
                        {
                            l.Estat = aplicacio.estat2;
                            aplicacio.guardarLineaComanda(l);
                        }
                        else if (l.QuantsFinalitzats == l.Quantitat) //Pot haver passat que un client hagués demanat primer 2plats,i al final resulta k només vol 1 i encara no s'han elaborat els 2..
                        {
                            l.Estat = aplicacio.estat3;
                            aplicacio.guardarLineaComanda(l);
                        }
                        
                        dataGridView1.Rows.Add(l.Quantitat, l.Producte.Nom.ToUpper(), aplicacio.determinaImatgeEstat(l.Estat), l.Estat, l.QuantsFinalitzats, null, null, l.NotaAdicional);
                        
                        //Cambia color del datagrid en funció de si es primer plat, segon o postres..
                        if (l.Preferencia == "1-Primer") //Si es primer plat
                        {
                            dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorPrimerPlat;
                            dataGridView1[8, dataGridView1.Rows.Count - 1].Value = "1-Primer";
                        }
                        else if (l.Preferencia == "2-Segon")
                        {
                            dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorSegonPlat;
                            dataGridView1[8, dataGridView1.Rows.Count - 1].Value = "2-Segon";
                        }
                        else if (l.Preferencia == "3-Postres")
                        {
                            dataGridView1.Rows[dataGridView1.Rows.Count - 1].DefaultCellStyle.BackColor = aplicacio.colorPostres;
                            dataGridView1[8, dataGridView1.Rows.Count - 1].Value = "3-Postres";
                        }
                        else //No pref
                        {
                           dataGridView1[8, dataGridView1.Rows.Count - 1].Value = "0-No Pref.";
                        }
                    }
                    guardar = true;
                    dataGridView1.Rows[0].Selected = false;
                    dataGridView1.Rows[indexAntic].Selected = true;

                   
                }
            }
            catch (Exception) { guardar = false; }
                
        }

        //Carrega les taules a la listBox de taules
        private void carregaTaules()
        {

            listView1.Clear();
            IList i = aplicacio.obtenirTaules();
            foreach (Taula t in i)
            {
                if (aplicacio.existeixComanda(t))
                {
                    String estat = aplicacio.obtenirComandaActual(t).Estat;
                    if (estat == aplicacio.estat1)
                        listView1.Items.Add(t.Nom, 0);
                    else if (estat == aplicacio.estat2)
                        listView1.Items.Add(t.Nom, 1);
                    else if (estat == aplicacio.comandaEstat3)
                        listView1.Items.Add(t.Nom, 2);
                    else //Eliminada
                        listView1.Items.Add(t.Nom, 4);
                }

                else //Si la taula es lliure
                    listView1.Items.Add(t.Nom, 3);
            }


        }
        //Ens serveix per saber si la base de dades a cambiat respecte el datagrid(algun nou producte entrat,o eliminat,acabat..etc)
        private bool hiHaCambis()
        {
            bool hiHaCambis = false;
            String producte;
            String nota;
            String preferencia;
            LineaComanda actual;
            int unitats;
            int finalitzats;
            int cont = dataGridView1.Rows.Count;

            while ((!hiHaCambis) && (cont > 0)) //Esquema de cerca,cerquem si hi ha hagut cambis a alguna linea per tal de refrescar o no
            {
                producte = (String)dataGridView1[1, cont - 1].Value;
                nota = (String)dataGridView1[7, cont - 1].Value;
                unitats = Convert.ToInt16(dataGridView1[0, cont - 1].Value);
                finalitzats = Convert.ToInt16(dataGridView1[4, cont - 1].Value);
                preferencia = (String)dataGridView1[8, cont - 1].Value;

                if (aplicacio.existeixLinea(comanda.Id, aplicacio.obtenirProducte(producte).Id, nota, preferencia))
                {
                    actual = aplicacio.obtenirLineaComanda(comanda.Id, aplicacio.obtenirProducte(producte).Id, nota, preferencia); //Obtenim la linea de la bd i la comparem amb la del datagrid
                    if ((actual.NotaAdicional != nota) || (actual.Quantitat != unitats) || (actual.QuantsFinalitzats != finalitzats)) //Només que hagi cambiat algun valor serà motiu per refrescar les linees,
                        hiHaCambis = true;
                }
                else hiHaCambis = true; //Si una linea no existeix a la bd es que ha estat eliminat
                cont--;
            }
            return hiHaCambis;
        }

        /****************************PANELL DE TAULES*******************************************************/
        //Escollir una taula
      
      
        private void listView1_ItemActivate(object sender, EventArgs e)
        {

            try //Avegades volem agafar un item que esta recargant-se i aixo produeix un error de nullpointer perquè encara no el tenim del tot carregat
            {
                String eleccio = listView1.FocusedItem.Text;
                taula = aplicacio.obtenirTaula(eleccio);
                string estat = aplicacio.obtenirComandaActual(taula).Estat;

                if (!estat.Equals("Lliure") && (!estat.Equals("Eliminada")))
                {
                    carregaLineas(taula);

                    label1.Text = "Nom Taula: " + taula.Nom;
                }

                
            }
            catch (Exception) {  }

        }

        /********************Click sobre la casella de afegir o treure productes finalitzats***********************/
        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

            if ((e.ColumnIndex == 5) || (e.ColumnIndex == 6))//Quan cliquem sobre la casella afegir, augmenta el nombre de productes acabats
            {
                
                LineaComanda l;
                string producte = (String)dataGridView1.CurrentRow.Cells[1].Value;
                string nota = (String)dataGridView1.CurrentRow.Cells["Column7"].Value;
                string preferencia = (String)dataGridView1.CurrentRow.Cells["Column9"].Value;

                l = aplicacio.obtenirLineaComanda(comanda.Id, aplicacio.obtenirProducte(producte).Id,nota,preferencia);
               
                if(e.ColumnIndex==5)
                aplicacio.determinaEstatLinea(l,"afegir");//Modifica l'estat de la linea i l'atribut QuantsFinalitzats
                else if(e.ColumnIndex == 6)
                aplicacio.determinaEstatLinea(l, "treure");//Modifica l'estat de la linea i l'atribut QuantsFinalitzats
                aplicacio.guardarLineaComanda(l);

                String estatComanda = aplicacio.determinaEstatComanda(comanda,opcio);
                comanda.Estat = estatComanda;
                aplicacio.guardarComanda(comanda); //Actualitza l'estat de la comanda*/
            }
        }


        
//****************** ACTUALITZACIÓ DE DADES*************************************************//      
        private void timer1_Tick(object sender, EventArgs e)
        {
            carregaTaules();
            if (taula != null)            
            {
                carregaLineas(taula);
                if (guardar)
                {
                    String estatComanda = aplicacio.determinaEstatComanda(comanda, opcio);
                    comanda.Estat = estatComanda;
                    aplicacio.guardarComanda(comanda); //Actualitza l'estat de la comanda
                }
            }

             
        }

        //Serveix per tenir les files amb més altura del normal
        private void dataGridView1_RowsAdded(object sender, DataGridViewRowsAddedEventArgs e)
        {
            dataGridView1.Rows[e.RowIndex].Height = 35;
        }

        

        

        


    }
}