/****************************************************************************************************************************************
/* Aquesta classe cont tots els mtodes comuns que utilitzarn els seus fills(gestorAplicacioGeneral i gestorAplicacioAdministrador)
 * i que sn mtodes per obtenir productes grupProductes i Cambrers.Com he dit aquests mtodes seran usats per tots els fills i llavors
 * cada fill implementar mtodes especifics del seu mdul 
 *****************************************************************************************************************************************/

using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.Windows.Forms;

using PFC.Controller;

namespace PFC.gestorAplicacio
{
    class gestor
    {
        public void IniciarAplicacio()
        {
            Controlador c = new Controlador();
            try
            {
                c.Inicialitzacio(); //Configura tot el mapeix de nhibernate i crea inici de sessi
            }
            catch (Exception e) { throw e; }
        }

//******************************Operacions de lectura de producte**********************************************
     
        //******************************Obtenim tots els productes disponibles************************
        public IList getProductes(){
            IList i = null;
            try
            {
              i= ControlProducte.getInstance().loadProductes();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

        //******************************Obtenim tots els productes de un grup************************
        public IList getProductes(GrupProducte g)
        {
            IList i = null;
            try
            {
                i = ControlProducte.getInstance().loadProductes(g);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }
        //******************************Obtenim el producte amb el id passat per parmetre************************
        public Producte getProducte(int id)
        {
            Producte p = null;
            try
            {
                p = ControlProducte.getInstance().loadProducte(id);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return p;
        }

        //******************************Obtenim el producte amb el string passat per parmetre************************
        public Producte getProducte(string s)
        {
            Producte p = null;
            try
            {
                p = ControlProducte.getInstance().loadProducte(s);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return p;
        }

        //******************************Obtenim els productes de un grup************************
        public IList getProductesGrup(GrupProducte gp)
        {
            return gp.Productes;
        }



 //******************************Operacions de lectura de grups producte**********************************************

        //******************************Obtenim tots els grups productes disponibles************************
        public IList getGrupsProductes()
        {
            IList i = null;
            try
            {
            i= ControlGrupProducte.getInstance().loadGrupsProductes();
             }
             catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK,MessageBoxIcon.Error); }
            return i;
        }

        //******************************Obtenim el grup producte amb el id passat per parmetre************************
        public GrupProducte getGrupProducte(int id)
        {
           GrupProducte gp=null;
            try{
            gp= ControlGrupProducte.getInstance().loadGrupProducte(id);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK,MessageBoxIcon.Error); }
            return gp;
        }

        //******************************Obtenim el grup producte amb el nom passat per parmetre************************
        public GrupProducte getGrupProducte(string s)
        {
            GrupProducte gp = null;
            try
            {
                gp = ControlGrupProducte.getInstance().loadGrupProducte(s);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return gp;
        }


 //******************************Operacions de lectura de cambrer**********************************************

        //******************************Obtenim tots els cambrers disponibles************************
        public IList getCambrers()
        {
            IList i = null;
            try
            {
            i= ControlCambrer.getInstance().loadCambrers();
             }
             catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK,MessageBoxIcon.Error); }
             return i;
        }

        //******************************Obtenim el cambrer amb el id passat per parmetre************************
        public Cambrer getCambrer(int id)
        {
            Cambrer ca= null;
            try{
           ca= ControlCambrer.getInstance().loadCambrer(id);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return ca;
        }


//******************************Operacions de lectura de taula**********************************************

        //******************************Obtenim tots les taules disponibles************************
        public IList getTaules()
        {
            IList i = null;
            try
            {
                i = ControlTaula.getInstance().loadTaules();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

        //******************************Obtenim la taula amb el id passat per parmetre************************
        public Taula getTaula(int id)
        {
            Taula ta = null;
            try
            {
                ta = ControlTaula.getInstance().loadTaula(id);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return ta;
        }

        //******************************Obtenim la taula amb el string passat per parmetre************************
        public Taula getTaula(string nom)
        {
            Taula ta = null;
            try
            {
                ta = ControlTaula.getInstance().loadTaula(nom);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return ta;
        }

        public IList getNotes()
        {

            IList i = null;
            try
            {
                i = ControlNotesAdicionals.getInstance().loadNotes();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

        
        public NotesAdicionals getNota(int id)
        {
            NotesAdicionals nota = null;
            try
            {
                nota = ControlNotesAdicionals.getInstance().loadNota(id);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return nota;
        }

        public NotesAdicionals getNota(string descripcio)
        {
            NotesAdicionals nota = null;
            try
            {
                nota = ControlNotesAdicionals.getInstance().loadNota(descripcio);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return nota;
        }


//******************************Operacions de lectura i escriptura de pagaments**********************************************

        //******************************Obtenim tots els pagaments disponibles************************
        public IList getPagaments()
        {
            IList i = null;
            try
            {
                i = ControlPagament.getInstance().loadPagaments();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

         //*********************************Filtratge de pagaments amb els camps tipus i data*********************************      
        public IList getPagaments(int idtipusPagament, String DataInici, String DataFinal)
        {
            IList i = null;
            try
            {
                i = ControlPagament.getInstance().loadPagaments(idtipusPagament, DataInici, DataFinal);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

        public IList getComandesNoPagades()
        {
            IList i = null;
            try
            {
                i = ControlComanda.getInstance().loadCobrosPendents();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

       
        public bool setPagament(Pagament p)
        {
            bool res = false;
            try
            {
              
                res = ControlPagament.getInstance().savePagament(p);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        public bool eliminaPagament(Pagament p)
        {
            bool res = true;

            try
            {
                res = ControlPagament.getInstance().deletePagament(p);
            }
            catch (Exception)
            {
                //MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); 
            }
            return res;
        }

//******************************Operacions de lectura i escriptura dels tipus de pagaments**********************************************
        //******************************Obtenim tots els tipus pagaments disponibles************************
        public IList getTipusPagaments()
        {
            IList i = null;
            try
            {
                i = ControlTipusPagament.getInstance().loadTipusPagaments();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

        public TipusPagament getTipusPagament(int id)
        {
            TipusPagament i = null;
            try
            {
                i = ControlTipusPagament.getInstance().loadTipusPagament(id);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return i;
        }

        public bool setTipusPagament(TipusPagament p)
        {
            bool res = false;
            try
            {
                res = ControlTipusPagament.getInstance().saveTipusPagament(p);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        public bool eliminaTipusPagament(TipusPagament p)
        {
            bool res = true;

            try
            {
                res = ControlTipusPagament.getInstance().deleteTipusPagament(p);
            }
            catch (Exception)
            {
                //MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); 
            }
            return res;
        }


    }
}
