/*******************************************************************************************************************************
 * Hereta de gestor:
 * Aqui tenim els mtodes especifics per l'aplicaci en mode administraci, s a dir, realitzar altes de productes nous,
 * grups de producte, i cambrers, aixi com modificar-los, i eliminar-los.
 ******************************************************************************************************************************/

using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using PFC.Controller;
using System.Windows.Forms;
namespace PFC.gestorAplicacio
{
    class gestorAplicacioAdministracio:gestor
    {
        

//******************************Operacions de escriptura de producte**********************************************
     
       
        //******************************Guardem i/o modifiquem el producte passat per parmetre************************
        public bool setProducte(Producte p)
        {
            bool res = false;
            try
            {
                GrupProducte gp = getGrupProducte(p.Grup.Id);
                gp.Productes.Add(p);  //Afegim el producte a la llista de productes del grup 
                res = ControlProducte.getInstance().saveProducte(p);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        //******************************Eliminem el producte passat per parmetre************************
        public bool eliminaProducte(Producte p)
        {
            bool res = true;

            p.Disponible = false;
            setProducte(p);

            try
            {
              res=  ControlProducte.getInstance().deleteProducte(p);
            }
            catch (Exception) { 
                //MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); 
            } 
            return res;
        }





 //******************************Operacions de escriptura de grups producte**********************************************

        //******************************Guardem i/o modifiquem el grup producte passat per parmetre************************
        public bool setGrupProducte(GrupProducte gp)
        {
            bool res = false;
            try
            {
                res = ControlGrupProducte.getInstance().saveGrupProducte(gp);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        //******************************Eliminem el Grupproducte passat per parmetre************************
        //Si el grup te productes associats ,primer eliminem els productes, i si els productes estan en alguna linea
        //no l'eliminem pero el possem a Disponible=false. Si passa aix el grup producte tampoc pot ser eliminat per la 
        //integritat referencial i tamb es posa a Disponibl=false

        public bool eliminaGrupProducte(GrupProducte p)
        {
            bool res = true;

            DialogResult d = MessageBox.Show("Estas a punt d'esborrar una familia de productes, el que comporta donar de baixa tots els productes que cont \n Vol continuar?", "Atenci", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation);

            if (d.ToString().Equals("OK"))
            {


                p.Disponible = false;
                setGrupProducte(p);
                IList i = p.Productes; //Eliminem els productes dependents, i si no es pot eliminar, queda en Disponible=false
                foreach (Producte pr in i)
                {
                    Producte p1=getProducte(pr.Id);
                    eliminaProducte(p1); 
                }


                try
                {
                    ControlGrupProducte.getInstance().deleteGrupProducte(p);
                }
                catch (Exception)
                {
                    // MessageBox.Show("Estas a punt d'esborrar una familia de productes, el que comporta donar de baixa tots els productes que cont /br Vol continuar?", "Atenci", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 

                }
            }
            else res = false;
            
            return res;
        }



//******************************Operacions de escriptura de cambrer**********************************************

        //******************************Guardem i/o modifiquem el cambrer passat per parmetre************************
        public bool setCambrer(Cambrer c)
        {
            bool res = false;
            try
            {
                 res= ControlCambrer.getInstance().saveCambrer(c);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        //******************************Eliminem el cambrer passat per parmetre************************
        public bool eliminaCambrer(Cambrer c)
        {
            bool res = true;
            //Abans de res posso la taula en estat desactivat (actiu=false) perqu si intento borrar i t comandes
            //associades no es podr borrar.Llavors ja quedar la taula en estat actiu = false que vol dir que s'ha 
            //eliminat i t comandes associades
            c.Actiu = false;
            setCambrer(c);
            try
            {
                res = ControlCambrer.getInstance().deleteCambrer(c);
            }
            catch (Exception) {
                //MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            return res;
        }



//******************************Operacions de escriptura de taula**********************************************

        //******************************Guardem i/o modifiquem la taula passada per parmetre************************
        public bool setTaula(Taula t)
        {
            
            bool res = false;
          
            try
            {
                res = ControlTaula.getInstance().saveTaula(t);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        //******************************Eliminem la taula passada per parmetre************************
        public bool eliminaTaula(Taula t)
        {
            bool res = true;

            //Abans de res posso la taula en estat desactivat (actiu=false) perqu si intento borrar i t comandes
            //associades no es podr borrar.Llavors ja quedar la taula en estat actiu = false que vol dir que s'ha 
            //eliminat i t comandes associades
            
            t.Activa = false;
            setTaula(t);


            try
            {
                res = ControlTaula.getInstance().deleteTaula(t);
            }
            catch (Exception) 
            {   
                               
               // MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            
            }
            

            return res;
        }


        //******************************Guardem i/o modifiquem la nota passada per parmetre************************
        public bool setNota(NotesAdicionals n)
        {

            bool res = false;

            try
            {
                res = ControlNotesAdicionals.getInstance().saveNota(n);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        //******************************Eliminem la taula passada per parmetre************************
        public bool eliminaNota(NotesAdicionals t)
        {
            bool res = true;

            
            try
            {
                res = ControlNotesAdicionals.getInstance().deleteNota(t);
            }
            catch (Exception ex)
            {

                 MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

            }


            return res;
        }


    }
}
