/*******************************************************************************************************************************
 * Hereta de gestor:
 * Aqui tenim els mtodes especifics per l'aplicaci en general, s a dir, realitzar comandes,lineas de comanda,anullar-les,
 * cobrar, etc..
 ******************************************************************************************************************************/

using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using PFC.Controller;
using System.Windows.Forms;
namespace PFC.gestorAplicacio
{
    class gestorAplicacioPrincipal:gestor
    {
        

//******************************Operacions de lectura comandes i linees**********************************************
     
       
        //******************************Retorna la comanda actual de la taula passada per parmetre************************
        public Comanda getComandaActual(Taula t)
        {
            Comanda c = null;
            try
            {
                c = ControlComanda.getInstance().loadComandaActual(t);
            }
            catch (Exception ) { 
               // MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); 
                throw new Exception();
            }
            return c;
        }

        public Comanda getComanda(int id)
        {
            Comanda com = null;
            try
            {
                com = ControlComanda.getInstance().loadComanda(id);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return com;
        }


        //******************************Retorna totes les comandes de la BD************************
        public IList getComandes()
        {
            IList c = null;
            try
            {
                c = ControlComanda.getInstance().loadComandes();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return c;
        }


        //******************************Retorna TOTES les linees de comanda actual de la taula passada per parmetre************************
        public IList getLineasComanda(Comanda c)
        {
            IList l = null;
            try
            {
                l = ControlLineaComanda.getInstance().loadLineasComanda(c);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return l;
        }

        //******************************Retorna de la comanda actual de la taula passada per parmetre les linees de cuina************************
        public IList getLineasCuina(Comanda c)
        {
            IList l = null;
            try
            {
                l = ControlLineaComanda.getInstance().loadLineasCuina(c);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return l;
        }

        //******************************Retorna de la comanda actual de la taula passada per parmetre les linees de barra************************
        public IList getLineasBarra(Comanda c)
        {
            IList l = null;
            try
            {
                l = ControlLineaComanda.getInstance().loadLineasBarra(c);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return l;
        }

        //******************************Retorna de la comanda actual de la taula passada per parmetre les linees de bodega************************
        public IList getLineasBodega(Comanda c)
        {
            IList l = null;
            try
            {
                l = ControlLineaComanda.getInstance().loadLineasBodega(c);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return l;
        }

        //******************************Retorna de la comanda actual de la taula passada per parmetre les linees de postres************************
        public IList getLineasPostres(Comanda c)
        {
            IList l = null;
            try
            {
                l = ControlLineaComanda.getInstance().loadLineasPostres(c);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return l;
        }
        //******************************Retorna totes les linees comanda de la BD************************
        public IList getLineasComanda()
        {
            IList c = null;
            try
            {
                c = ControlLineaComanda.getInstance().loadLineasComanda();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return c;
        }

        //******************************Retorna una linea de comanda************************
        public LineaComanda getLineaComanda(int comanda,int producte,string nota,string preferencia)
        {
            LineaComanda c = null;
            try
            {
                c = ControlLineaComanda.getInstance().loadLineaComanda(comanda, producte,nota,preferencia);
            }
            catch (Exception) { 
            //    MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); 
                throw new Exception(); //Servir pel metode existeixLinea,que es basar en saber si ha petat anteriorment(significaria que no hi es..)
            }
            return c;
        }


 //******************************Operacions de escriptura comandes i linees**********************************************

       //******************************Guardem i/o modifiquem la comanda passada per parmetre************************
        public bool setComanda(Comanda c)
        {
            bool res = false;
            try
            {
                res = ControlComanda.getInstance().saveComanda(c);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;
        }

        //******************************Eliminem la comanda passat per parmetre************************
        public bool eliminaComanda(Comanda c)
        {
            bool res = true;

            
            try
            {
                res = ControlComanda.getInstance().deleteComanda(c);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); 
            }
            return res;
        }

         //******************************Guardem la lineacomanda a la bd************************
        public bool setLineaComanda(LineaComanda l)
        {
            bool res = false;
            try
            {
                res = ControlLineaComanda.getInstance().saveLineaComanda(l);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            return res;

        }

        //******************************Eliminem la lineacomanda passada per parmetre************************
        public bool eliminaLineaComanda(LineaComanda l)
        {
            bool res = true;


            try
            {
                res = ControlLineaComanda.getInstance().deleteLineaComanda(l);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); 
            }
            return res;
        }

          }
}
