DROP TABLE IF EXISTS `grupproducte` ;
CREATE TABLE `grupproducte` (
  `IdGrup` int(10) NOT NULL auto_increment,
  `NomGrup` varchar(50) default NULL,
  `Disponible` tinyint(1) NOT NULL default '1',
  `Enviar_a` varchar(45) default NULL,
  PRIMARY KEY  (`IdGrup`),
  UNIQUE KEY `Index_2` (`NomGrup`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ;



DROP TABLE IF EXISTS `cambrer` ;
CREATE TABLE `cambrer` (
  `IdCambrer` int(10) NOT NULL auto_increment,
  `Nom` varchar(50) default NULL,
  `Cognoms` varchar(50) default NULL,
  `Password` varchar(45) default NULL,
  `Actiu` tinyint(1) NOT NULL default '1',
  
  PRIMARY KEY  (`IdCambrer`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `taula` ;
CREATE TABLE `taula` (
  `IdTaula` int(10) NOT NULL auto_increment,
  `Nom` varchar(45) NOT NULL default '',
  `Activa` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`IdTaula`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ;


DROP TABLE IF EXISTS `producte`;
CREATE TABLE `producte` (
  `IdProducte` int(10) NOT NULL auto_increment,
  `Nom` varchar(50) default NULL,
  `Preu` float NOT NULL default '0',
  `IdGrup` int(10) NOT NULL default '0',
  `Disponible` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`IdProducte`),
  KEY `FK_producte_1` (`IdGrup`),
  CONSTRAINT `FK_producte_1` FOREIGN KEY (`IdGrup`) REFERENCES `grupproducte` (`IdGrup`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;




DROP TABLE IF EXISTS `comanda` ;
CREATE TABLE `comanda` (
  `IdComanda` int(10) NOT NULL auto_increment,
  `Data` datetime default NULL,
  `IdTaula` int(10) NOT NULL default '0',
  `Estat` varchar(50) default NULL,
  `Preu` float NOT NULL default '0',
  `PreuModificat` float NOT NULL default '0',
  PRIMARY KEY  (`IdComanda`),
  KEY `Index_2` (`IdTaula`),
  CONSTRAINT `FK_comanda_1` FOREIGN KEY (`IdTaula`) REFERENCES `taula` (`IdTaula`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ;


DROP TABLE IF EXISTS `lineacomanda` ;
CREATE TABLE `lineacomanda` (
  `IdComanda` int(10) NOT NULL default '0',
  `IdProducte` int(10) NOT NULL default '0',
  `Quantitat` int(10) NOT NULL default '1',
  `Estat` varchar(20) default NULL,
  `IdCambrer` int(10) default NULL,
  `IdLineaComanda` int(10) NOT NULL auto_increment,
  `QuantsFinalitzats` int(10) NOT NULL default '0',
   `NotaAdicional` text default NULL,
`Preferencia` varchar(45) default NULL,
  PRIMARY KEY  (`IdLineaComanda`),
  KEY `FK_lineacomanda_2` (`IdProducte`),
  KEY `FK_lineacomanda_3` (`IdCambrer`),
  CONSTRAINT `FK_lineacomanda_1` FOREIGN KEY (`IdComanda`) REFERENCES `comanda`(`IdComanda`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_lineacomanda_2` FOREIGN KEY (`IdProducte`) REFERENCES `producte` (`IdProducte`),
  CONSTRAINT `FK_lineacomanda_3` FOREIGN KEY (`IdCambrer`) REFERENCES `cambrer`(`IdCambrer`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='InnoDB free: 11264 kB' ;



DROP TABLE IF EXISTS `notesadicionals` ;
CREATE TABLE `notesadicionals` (
  `IdNota` int(10) NOT NULL auto_increment,
  `Descripcio` text NOT NULL,
  `IdGrup` int(10) NOT NULL default '0',
  PRIMARY KEY  (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ;


DROP TABLE IF EXISTS `pagament` ;
CREATE TABLE `pagament` (
  `IdPagament` int(10) NOT NULL auto_increment,
  `IdTipus` int(11) NOT NULL default '0',
  `Data` datetime NOT NULL default '0000-00-00 00:00:00',
  `Import` float NOT NULL default '0',
  `IdComanda` int(10) NOT NULL default '0',
  PRIMARY KEY  (`IdPagament`),
  KEY `Index_2` (`IdComanda`),
  KEY `FK_pagament_2` (`IdTipus`),
  CONSTRAINT `FK_pagament_1` FOREIGN KEY (`IdComanda`) REFERENCES `comanda` (`IdComanda`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_pagament_2` FOREIGN KEY (`IdTipus`) REFERENCES `tipuspagament`(`IdTipus`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ;


DROP TABLE IF EXISTS `tipuspagament` ;
CREATE TABLE `tipuspagament` (
  `IdTipus` int(10) NOT NULL auto_increment,
  `Descripcio` varchar(45) NOT NULL default '',
  PRIMARY KEY  (`IdTipus`),
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ;


INSERT INTO `projecte`.`cambrer`(`IdCambrer`, `Nom`, `Cognoms`, `Password`, `Actiu`)
VALUES (1, "Xavi", "Sol", "", 1);

INSERT INTO `projecte`.`comanda`(`IdComanda`, `Data`, `IdTaula`, `Estat`, `Preu`, `PreuModificat`)
VALUES (5, "2006-07-18 21:29:24", 3, "Eliminada", 0, 0),
  (6, "2006-07-18 14:39:11", 5, "Eliminada", 0, 0);

INSERT INTO `projecte`.`grupproducte`(`IdGrup`, `NomGrup`, `Disponible`, `Enviar_a`)
VALUES (49, "Licors", 1, "Barra"),
  (71, "Refrescs", 1, "Barra"),
  (72, "Entrepans", 1, "Cuina"),
  (74, "Carn i peix", 1, "Cuina"),
  (75, "Vins", 1, "Bodega"),
  (76, "Cava", 1, "Bodega");

INSERT INTO `projecte`.`notesadicionals`(`IdNota`, `Descripcio`, `IdGrup`)
VALUES (1, "Sense ceba", 72),
  (2, "Molt fet", 74),
  (3, "Sense tomquet", 72),
  (4, "Volta i volta", 74),
  (5, "Sense salt", 74),
  (6, "Amb gel", 71),
  (7, "Doble", 49);

INSERT INTO `projecte`.`producte`(`IdProducte`, `Nom`, `Preu`, `IdGrup`, `Disponible`)
VALUES (9, "Orujo", 1.5, 49, 1),
  (10, "Bacardi", 1.32, 49, 1),
  (11, "103", 2.5, 49, 1),
  (12, "1900", 2.2, 49, 1),
  (13, "Baileys", 1.2, 49, 1),
  (14, "Coca-cola", 1.5, 71, 1),
  (16, "Entrep de pernil", 2.7, 72, 1),
  (17, "Hamburguesa", 3.75, 72, 1),
  (18, "Hot dog", 2.75, 72, 1),
  (19, "Pepsi", 1.34, 71, 1);

INSERT INTO `projecte`.`taula`(`IdTaula`, `Nom`, `Activa`)
VALUES (1, "taula 1", 1),
  (2, "taula 2", 1);

INSERT INTO `projecte`.`tipusPagament`(`IdTipus`, `Descripcio`)
VALUES ("Metllic"),
  ("Visa"),
  ("Maestro"),
  ("MasterCard");